;   com-,   IR

.nolist
.include "/usr/local/include/avr/m8def.inc"
.list

; :
; r0..r3	- Flash, VideoCPU, Math
; r4..r7	- Flash, Math
; r8..r11	- Interrupt Ext0				+++GLOBAL+++
; r12		-  
; r8, r13..r15	- Interrupt Timer				+++GLOBAL+++
; r16		- _all_
; r17		- _all_
; r18..r21	- Interrupt Ext0				+++GLOBAL+++
; r22		-   				+++GLOBAL+++
; r23		- VideoCPU, Tuner&Video
; r24..r25	- _all_
; r26..r27	- _all_ [x]
; r28..r29	-      [Y]	+++GLOBAL+++
; r30..r31	- _all_ [Z]

;
;  OSD
;
.equ	BLACK		= 0		;   OSD
.equ	RED		= 4
.equ	BLUE		= 1
.equ	GREEN		= 2
.equ	YELLOW		= GREEN+RED
.equ	LBLUE		= GREEN+BLUE
.equ	WHITE		= GREEN+RED+BLUE

.equ	B_TRANS		= 0x80		;   OSD
.equ	B_BLACK		= 0x00
.equ	B_RED		= 0x40
.equ	B_BLUE		= 0x10
.equ	B_GREEN		= 0x20
.equ	B_YELLOW	= B_GREEN+B_RED
.equ	B_LBLUE		= B_GREEN+B_BLUE
.equ	B_WHITE		= B_GREEN+B_RED+B_BLUE

.equ	MAXX		= 32		;     (   - 22)
.equ	MAXY		= 7		;  

;
;   
;
.equ	twibr		= 32		;  TWI 100   8   [ sclf = mainf / (16+2(twbr)*(4^twps)) ]
.equ	rtctop		= 12500-1	;    1   10     prescaler == 64   8 

;
;   EPROM
;
.equ	CH_max		= 100		;     .      
.equ	FLB_10_12	= 127		;   ,     VDc10..VDc12

;
;   
;
.def	VDs0		= r0
.def	VDs1		= r1
.def	VDs2		= r2
;
.def	rVD_POR		= VDs0
.equ	pVD_POR		= 7
.def	rVD_FSI		= VDs0
.equ	pVD_FSI		= 6
.def	rVD_SL		= VDs0
.equ	pVD_SL		= 4
.def	rVD_XPR		= VDs0
.equ	pVD_XPR		= 3
.def	rVD_CD2		= VDs0
.equ	pVD_CD2		= 2
.def	rVD_CD1		= VDs0
.equ	pVD_CD1		= 1
.def	rVD_CD0		= VDs0
.equ	pVD_CD0		= 0

.def	rVD_NDF		= VDs1
.equ	pVD_NDF		= 7
.def	rVD_IN1		= VDs1
.equ	pVD_IN1		= 6
.def	rVD_IFI		= VDs1
.equ	pVD_IFI		= 4
.def	rVD_AFA		= VDs1
.equ	pVD_AFA		= 3
.def	rVD_AFB		= VDs1
.equ	pVD_AFB		= 2
.def	rVD_SXA		= VDs1
.equ	pVD_SXA		= 1
.def	rVD_SXB		= VDs1
.equ	pVD_SXB		= 0

.def	rVD_N2		= VDs2
.equ	pVD_N2		= 7
.def	rVD_BCF		= VDs2
.equ	pVD_BCF		= 5
.def	rVD_IVW		= VDs2
.equ	pVD_IVW		= 4
.def	rVD_ID3		= VDs2
.equ	pVD_ID3		= 3
.def	rVD_ID2		= VDs2
.equ	pVD_ID2		= 2
.def	rVD_ID1		= VDs2
.equ	pVD_ID1		= 1
.def	rVD_ID0		= VDs2
.equ	pVD_ID0		= 0

;
; IO-
;
.equ	riIRInput	= PIND		; <- -			!!! NB:    -
.equ	roIRInput	= PORTD		;    pull-up
.equ	pIRInput	= 2

.equ	riInitial	= PIND		;       0', 
.equ	roInitial	= PORTD		;     EPROM
.equ	pInitial	= 3

.equ	riHeatMon	= PIND		; <-   , 0 -  
.equ	roHeatMon	= PORTD		;   pullup
.equ	pHeatMon	= 6

.equ	rdHeat1		= DDRB		; ->   , 1 - 
.equ	roHeat1		= PORTB
.equ	pHeat1		= 1

.equ	rdHeat2		= DDRB		; ->   , 1 - 
.equ	roHeat2		= PORTB
.equ	pHeat2		= 2

.equ	rdPower		= DDRB		; ->  , 1 - 
.equ	roPower		= PORTB
.equ	pPower		= 3

.equ	rdBell		= DDRB		; -> , 0 - 
.equ	roBell		= PORTB
.equ	pBell		= 4

.equ	riPowerMon	= PINB		; <-   , 1 -  
.equ	pPowerMon	= 5

.equ	rdMon0		= DDRC		;     ,   i2c
.equ	roMon0		= PORTC
.equ	pMon0		= 0

.equ	rdMon1		= DDRC
.equ	roMon1		= PORTC
.equ	pMon1		= 1

					; ADC2 [PC2] - AGC monitor


.equ	rdLight		= DDRC		; -> , 1 - 
.equ	roLight		= PORTC
.equ	pLight		= 3

;
;  
;
.def	FlagReg		= r12
.equ	FR_MenuVis	= 0		;    .  
.equ	FR_FirstDig	= 1		;     
.equ	FR_DoubleDig	= 2		;      
.equ	FR_SigLevel	= 3		;   

;
;   
;
.dseg

ODattr:	.byte	1	;  ,   OSD  od_CharOut

CH_cur:	.byte	1	;  -
CH_last:.byte	1	;  
CH_dst:	.byte	1	;  ,      
CH_fd:	.byte	1	;         ģ 

IVtimer:.byte	1	;     

VDc14a: .byte	1	;  VDc14    

.equ	VDcCNT	= 22	;    
VDc:			;   
VDc00:	.byte	1
VDc01:	.byte	1
VDc02:	.byte	1
VDc03:	.byte	1

VDc08:	.byte	1
VDc09:	.byte	1
VDc0a:	.byte	1
VDc0b:	.byte	1

VDc0c:	.byte	1
VDc0d:	.byte	1
VDc0e:	.byte	1
VDc0f:	.byte	1

VDc10:	.byte	1
VDc11:	.byte	1
VDc12:	.byte	1
VDc13:	.byte	1

VDc14:	.byte	1
VDc15:	.byte	1

VDc18:	.byte	1
VDc19:	.byte	1
VDc1a:	.byte	1
VDc1b:	.byte	1


TNDivL:	.byte	1	;   
TNDivH:	.byte	1	;            /
TNCtl0:	.byte	1	;   
TNCtl1:	.byte	1


.cseg

.org	0x000
 rjmp	RESET		; Reset Handler
 rjmp	EXT_INT0	; IRQ0 Handler
 rjmp	EXT_INT1	; IRQ1 Handler
 rjmp	TIM2_COMP	; Timer2 Compare Handler
 rjmp	TIM2_OVF	; Timer2 Overflow Handler
 rjmp	TIM1_CAPT	; Timer1 Capture Handler
 rjmp	TIM1_COMPA	; Timer1 CompareA Handler
 rjmp	TIM1_COMPB	; Timer1 CompareB Handler
 rjmp	TIM1_OVF	; Timer1 Overflow Handler
 rjmp	TIM0_OVF	; Timer0 Overflow Handler
 rjmp	SPI_STC		; SPI Transfer Complete Handler
 rjmp	USART_RXC	; USART RX Complete Handler
 rjmp	USART_UDRE	; UDR Empty Handler
 rjmp	USART_TXC	; USART TX Complete Handler
 rjmp	ADCR		; ADC Conversion Complete Handler
 rjmp	EE_RDY		; EEPROM Ready Handler
 rjmp	ANA_COMP	; Analog Comparator Handler
 rjmp	TWSI		; Two-wire Serial Interface
 rjmp	SPM_RDY		; Store Program Memory Ready

;;==========================================================================
;;    # 0 - IR
;;  r8, r9, r10 [IRData], r11 [IRRecv], r18, r19, r20, r21
;;
.equ	IRPort	= riIRInput
.equ	IRBit	= pIRInput
.def	IRData	= r10		;      | 0x80 -   
.def	IRRecv	= r11		;   IRData
;
EXT_INT0:
 in	r8, SREG

;   
;    ,    

 clr	r19
INT0_0:
 inc	r19
 rcall	INT0_IRTest
 brcc	INT0_0

 subi	r19, 76		;     7800 ...
 brlo	INT0_2		; ...  

;   
;     

 clr	r19
INT0_1:
 inc	r19
 breq	INT0_2		;     -  
 rcall	INT0_IRTest
 brcs	INT0_1

 subi	r19, 26-1	;    ~3600   ~1700 
 brlo	INT0_4		;  ""

;   -  

 rcall	INT0_RecvDByte
 brcc	INT0_2		;  ɣ
 cpi	r21, 0x04
 brne	INT0_2		;     0x04

 rcall	INT0_RecvDByte
 brcc	INT0_2		;  ɣ
 rjmp	INT0_5

INT0_4:
 sbrc	Timer10a, 7
 rjmp	INT0_2
 mov	r21, IRData
 ori	r21, 0x80

INT0_5:
 mov	IRData, r21
 clr	IRRecv
 com	IRRecv
 ldi	r19, 5
 mov	Timer10a, r19	;          -
			;  ""   
INT0_2:
 out	SREG, r8
 reti

;   IR  ,     
; C = 0   
;  r9, r18, r19, r20,   r21  r9

INT0_RecvDByte:
 rcall	INT0_RecvByte
 brcc	INT0_RDB_ret
 mov	r9, r21
 rcall	INT0_RecvByte
 brcc	INT0_RDB_ret
 com	r21		; ! r21, c == 1
 cpse	r9, r21		; skip 'clc' if r9 == r21
 clc
INT0_RDB_ret:
 ret

;   IR 
; C = 0   timeout'a
;  r18, r19, r20,   r21

INT0_RecvByte:
 clr	r21
 ldi	r19, 8

INT0_RB_0:
 rcall	INT0_IRTest
 brcc	INT0_RB_0	;  -"1"

 ldi	r20, 19		;   2000  (    1500,
			; ,    ATmeg'  )

INT0_RB_1:		;   
 rcall	INT0_IRTest
 brcc	INT0_RB_2	;  
 dec	r20
 brpl	INT0_RB_1	;   15  0 
 clc
 ret

INT0_RB_2:		; C = 0
; sbrs	r20, 3		;    2000/2  -  "0"
; sec
 cpi	r20, 10		; ????  !!!
 ror	r21

 dec	r19
 brne	INT0_RB_0
 sec
 ret

;  5    100 ,  C = 0     IR = 0
;  r18

INT0_IRTest:
 sec
 ldi	r18, 5

INT0_IRT_0:
 rcall	Wait20mks
 sbis	IRPort, IRBit
 clc
 dec	r18
 brne	INT0_IRT_0

 ret

;;==========================================================================
;;    10 
;;  r8,  ģ  r13, r14, r15 -    1,   -1.
;;
.def	Timer10a	= r13	;      IR
.def	Timer10b	= r14	;    Info  OSD (-1 -   , -2 -   )
.def	Timer10c	= r15	;        
;
TIM1_COMPA:
 in	r8, SREG
 sbrs	Timer10a, 7
 dec	Timer10a
 sbrs	Timer10b, 7
 dec	Timer10b
 sbrs	Timer10c, 7
 dec	Timer10c
 out	SREG, r8
 reti

;;==========================================================================
;;     
;;     sizeof(PC) = 16
;;

;
;   500  250 
;  r16, r17
;
Wait500ms:
 rcall	Wait250ms
Wait250ms:
 ldi	r17, 125
W_2:
 rcall	Wait2ms
 dec	r17
 brne	W_2
 ret
;
;   2  ~= 163  * 98
;  r16
;
Wait2ms:
 ldi	r16, 98
W_1:
 rcall	Wait20mks	; 160
 dec	r16		; 1
 brne	W_1		; 2
 ret
;
Wait20mks:		; 3	8*20 = 160
 rcall	Wait5mks	; 40
 rcall	Wait5mks	; 40
 rcall	Wait5mks	; 40	+ 37
;
Wait5mks:		; 3	40  = 5 
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8	+ 5
;
Wait1mks:		; 3	8    8  = 1 
 nop			; 1
 ret			; 4

;;==========================================================================
;;  
;;
EXT_INT1:
TIM2_COMP:
TIM2_OVF:
TIM1_CAPT:
;
TIM1_COMPB:
TIM1_OVF:
TIM0_OVF:
SPI_STC:
USART_RXC:
USART_UDRE:
USART_TXC:
ADCR:
EE_RDY:
ANA_COMP:
TWSI:
SPM_RDY:

;;==========================================================================
;;  
;;
RESET:				; Main program start
 ldi	r16, high(RAMEND)
 out	SPH, r16		; Set Stack Pointer to top of RAM
 ldi	r16, low(RAMEND)
 out	SPL, r16

;
;      pullup'
;

 ldi	r16, (1<<pIRInput) | (1<<pHeatMon) | (1<<pInitial)
 out	roIRInput, r16				; PortD: PullUp IR & HeatMon & Initial

 ldi	r16, (1<<pHeat1) | (1<<pHeat2) | (1<<pPower) | (1<<pBell)
 out	rdHeat1, r16				; PortB:     

 ldi	r16, (1<<pMon0) | (1<<pMon1) | (1<<pLight)
 out	rdLight, r16				; PortC:  - 

 sbi	roBell, pBell				;  

;
;   0
;

; out TCCR1A, 0x00		; By default

 ldi	r16, (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (1<<CS11) | (1<<CS10)
 out	TCCR1B, r16

 ldi	r16, high(rtctop)
 out	OCR1AH, r16
 ldi	r16, low(rtctop)
 out	OCR1AL, r16

 ldi	r16, (1<<OCIE1A)
 out	TIMSK, r16

;
;  ,   
;

 ldi	r16, (1<<INT0)
 out	GICR, r16

;
;  i2c
;

 rcall	i_Init

;
;  RAM-  VideoCPU
;

 rcall	v_InitVal
 sbis	riInitial, pInitial
 rjmp	Main9			;  pInitial    -    EPROM 
 ldi	r24, FLB_10_12
 rcall	f_Read
 sts	VDc10, r0
 sts	VDc11, r1
 sts	VDc12, r2
Main9:

;
;   
;
 ldi	r16, 1
 sts	CH_cur, r16
 sts	CH_last, r16

 ldi	r16, 0x82
 sts	TNCtl0, r16

;
;  ADC
;
 ldi	r16, (1<<REFS0) | (1<<ADLAR) | (1<<MUX1)
 out	ADMUX, r16

 ldi	r16, (1<<ADEN) | (1<<ADSC) | (1<<ADFR) | (7<<ADPS0)
 out	ADCSR, r16

;
;       
;
PowerOff:
 cli
 ldi	r16, high(RAMEND)	;         
 out	SPH, r16
 ldi	r16, low(RAMEND)
 out	SPL, r16
 sei

 rcall	pw_Off

;
;   'Power'
;
 clr	IRData
Main0:
 mov	r16, IRData
 cpi	r16, 0x08
 brne	Main0
 clr	IRRecv

;
;   
;
 rcall	pw_On

;
;  ,   i2c
;
 rcall	i_Stop			;          ATmega-i2c
 				; ,    ,  PullUp     
 rcall	od_Init			;    OSD
 rcall	od_ClrScr		;  

 rcall	v_InitHard		;       

 rcall	t_Read			;  ...
 rcall	ch_Goto			; ...    

;
;   
;
 clr	FlagReg
 rcall	v_MuteOff		;        -  
 ldi	r16, 6			;      IV
 sts	IVtimer, r16

;;==========================================================================
;;   (  )
;;
MainMain:
 sbi	roLight, pLight

;
;     
;
 bst	Timer10c, 7		;  10 ,   100 ( 127 ) - 10 
 brtc	Main7

 ldi	r16, 100
 mov	Timer10c, r16

 rcall	v_Read
 lds	r26, IVTimer
 sbrc   rVD_IFI, pVD_IFI
 ldi	r26, 6			;  0.1 ,   6   
 dec	r26
 sts	IVTimer, r26
 breq	PowerOff		;     0 -   -  60 

Main7:

;
;   
;
; sbrs	FlagReg, FR_MenuVis
 sbrs	FlagReg, FR_SigLevel
 rjmp	Main6

 ldi	r16, YELLOW+B_TRANS
 ldi	r26, 0x20*6 + 16
 rcall	od_Tab_Attr

 ldi	r17, 'L'
 rcall	od_CharOut

 ldi	r16, RED+B_TRANS
 sts	ODattr, r16

 in	r0, ADCH
 com	r0
 rcall	DecByteOut

 rcall	i_Stop

Main6:

;
;  -    ,
;       
;
 mov	r16, Timer10b
 cpi	r16, -1
 brne	Main1			; Timer10b = 255 -  ,  
 dec	Timer10b		; Timer10b = 254 -  ,    
 rcall	od_ClrScr
 clt
 bld	FlagReg, FR_FirstDig	;          -   
Main1:

;
;    
;
 tst	IRRecv
 breq	MainMain
 cbi	roLight, pLight

;
;       
;
 clr	IRRecv
 ldi	r17, 25
 ldi	r30, low(M_KeyTable*2)
 ldi	r31, high(M_KeyTable*2)

Main2:			;    
 lpm	r24, Z+
 lpm	r25, Z+
 and	r25, IRData
 cp	r24, r25
 breq	Main3

 adiw	Z, 2
 dec	r17
 brne	Main2
 rjmp	MainMain
;
Main3:			;  -,      
 lpm	r24, Z+
 lpm	r25, Z+
 movw	r30, r24
 bst	FlagReg, FR_MenuVis
			;      T,       
 icall

 sbrc	FlagReg, FR_MenuVis
 rcall	mn_Draw		;      -   
 rjmp	MainMain

;         IR 
;          

M_KeyTable:
 .db	0x08, 0xFF
 .dw	key_Power
 .db	0x09, 0xFF
 .dw	key_Mute
 .db	0x1c, 0xFF
 .dw	key_EnMode
 .db	0x1b, 0xFF
 .dw	key_ReCall

 .db	0x00, 0x7F
 .dw	key_Up
 .db	0x01, 0x7F
 .dw	key_Down
 .db	0x02, 0x7F
 .dw	key_Right
 .db	0x03, 0x7F
 .dw	key_Left
 .db	0x44, 0xFF
 .dw	key_Ok

 .db	0x10, 0xFF
 .dw	key_0
 .db	0x11, 0xFF
 .dw	key_1
 .db	0x12, 0xFF
 .dw	key_2
 .db	0x13, 0xFF
 .dw	key_3
 .db	0x14, 0xFF
 .dw	key_4
 .db	0x15, 0xFF
 .dw	key_5
 .db	0x16, 0xFF
 .dw	key_6
 .db	0x17, 0xFF
 .dw	key_7
 .db	0x18, 0xFF
 .dw	key_8
 .db	0x19, 0xFF
 .dw	key_9

 .db	0x0b, 0xFF
 .dw	key_TVAV
 .db	0x43, 0xFF
 .dw	key_Menu
 .db	0x4f, 0xFF
 .dw	key_PSM
 .db	0x0e, 0xFF
 .dw	key_Sleep
 .db	0x1a, 0xFF
 .dw	key_QView
 .db	0x0c, 0xFF
 .dw	key_Picture

;;==========================================================================
;;     
;;

;
;    
;
key_0:
key_1:
key_2:
key_3:
key_4:
key_5:
key_6:
key_7:
key_8:
key_9:
 mov	r16, IRData
 andi	r16, 0x0F
 
 sbrs	FlagReg, FR_DoubleDig
 rjmp	key_D_1				;   
 sbrc	FlagReg, FR_FirstDig
 rjmp	key_D_2				;   

 set
 bld	FlagReg, FR_FirstDig
 ldi	r17, 10
 mul	r16, r17
 sts	CH_fd, r0			;   
 mov	r17, r16

 ldi	r16, LBLUE
 rcall	ch_Tab

 subi	r17, -('0')
 rcall	od_CharOut
 ldi	r17, 0x3E
 rcall	od_CharOut

 rjmp	i_Stop

key_D_2:
 clt
 bld	FlagReg, FR_FirstDig
 lds	r17, CH_fd
 add	r16, r17

key_D_1:
 lds	r17, CH_cur
 sts	CH_last, r17
 sts	CH_cur, r16
 rjmp	ch_GoTo

;
;  
;
key_Power:
 rjmp	PowerOff

;
;      Mute mode
;
key_Mute:
 rjmp	v_MuteChg

;
;     
;
key_EnMode:
 mov	r16, FlagReg
 ldi	r17, (1<<FR_DoubleDig)
 eor	r16, r17
 mov	FlagReg, r16

 clt
 bld	FlagReg, FR_FirstDig		;      
 bst	FlagReg, FR_DoubleDig

 ldi	r16, RED
 rcall	ch_Tab

 ldi	r17, 0x3E
 rcall	od_CharOut

 brts	key_EM_1
 ldi	r17, ' '
key_EM_1:
 rcall	od_CharOut

 rjmp	i_Stop

;
; ????????                
;
key_ReCall:
 rjmp	tv_FineTuning

;
;      
;
key_Up:
 brts	mn_Prev
 lds	r16, CH_cur
 sts	CH_last, r16
 rjmp	ch_Next

;
;      
;
key_Down:
 brts	mn_Next
 lds	r16, CH_cur
 sts	CH_last, r16
 rjmp	ch_Prev

;
;     
;
key_Right:
 brts	mn_Right
 ldi	r26, low(VDc14) + 0x00
 rjmp	v_ChangeVolume

;
;     
;
key_Left:
 brts	mn_Left
 ldi	r26, low(VDc14) + 0x80
 rjmp	v_ChangeVolume

;
;      Mute mode
;
key_Ok:
 brts	mn_Ok
 rjmp	v_MuteChg

;
; ?????????
;
key_TVAV:
 mov	r16, FlagReg
 ldi	r17, (1<<FR_SigLevel)
 eor	r16, r17
 mov	FlagReg, r16
 rjmp	od_ClrScr	;     -  

;
; ????????       
;
key_Menu:
 lds	r16, CH_cur
 sts	CH_dst, r16
 ldi	r28, low(M_Tuner*2)
 ldi	r29, high(M_Tuner*2)
 rjmp	mn_On

;
; ?????????
;
key_PSM:
 ldi	r28, low(M_Speed*2)
 ldi	r29, high(M_Speed*2)
 rjmp	mn_On

;
; ????????       
;
key_Sleep:
 rjmp	About

;
;     
;
key_QView:
 lds	r16, CH_cur
 lds	r17, CH_last
 sts	CH_last, r16
 sts	CH_cur, r17
 rjmp	ch_GoTo

;
;   //
;
key_Picture:
 ldi	r28, low(M_Pic*2)
 ldi	r29, high(M_Pic*2)
 rjmp	mn_On

;;==========================================================================
;;     
;;
.def	mn_Cursor	= r22

;
;     
;
mn_Prev:
 tst	MN_Cursor
 breq	ret2		;    
 dec	MN_Cursor
 mov	r16, MN_Cursor
 rcall	mn_Locate
 brtc	mn_Prev		;  ,    
 ret 

;
;     
;
mn_Next:
 mov	r16, MN_Cursor
 inc	r16
 rcall	mn_Locate
 breq	ret2		;   -  (̣)
 inc	MN_Cursor
 brtc	mn_Next		;  ,    
 ret

;
;  , , OK -   
;
mn_Left:
 rcall	mn_SubArrow
 breq	mn_L_1
 ori	r26, 0x80
 rjmp	v_ChangeVal

mn_L_1:
 adiw	Z, 0x8-3
 rjmp	mn_Action

;
mn_Right:
 rcall	mn_SubArrow
 breq	mn_R_1
 rjmp	v_ChangeVal

mn_R_1:
 adiw	Z, 0xC-3
 rjmp	mn_Action

;
mn_OK:
 rcall	mn_SubArrow
 adiw	Z, 0xA-3
 rjmp	mn_Action

;    ,         
mn_SubArrow:
 mov	r16, MN_Cursor
 rcall	mn_Locate
 adiw	Z, 3
 lpm	r26, Z
 tst	r26
ret2:
 ret

;
;  
;
mn_Off:
 clt
 bld	FlagReg, FR_MenuVis
 rjmp	od_ClrScr

;
;     
; Y      
;
mn_On:
 sbrc	FlagReg, FR_MenuVis
 rjmp	mn_Off				;       -  
 set
 bld	FlagReg, FR_MenuVis
 clr	mn_Cursor
 rcall	od_ClrScr			;  , ,     -  

;
;    
;
mn_Draw:
 clr	r16
mn_D_1:
 rcall	mn_Locate
 breq	mn_D_2
 push	r16
 rcall	mn_DrawItem
 pop	r16
 inc	r16
 rjmp	mn_D_1
 
mn_D_2:
 rjmp	i_Stop		; mn_DrawItem    OSD,   
;
;   ,    Z
;   r16      (   MN_Cursor)
;     i_Stop
;
mn_DrawItem:
 mov	r17, r16

;   

 lpm	r26, Z+
 cbr	r26, 0x01
 rcall	od_Tab

;    

 lpm	r27, Z+
 lpm	r26, Z+
 cpse	r17, MN_Cursor
 mov	r26, r27
 sts	ODattr, r26
 
;  

 lpm	r26, Z+
 push	r26

 lpm	r26, Z+
 lpm	r27, Z+
 push	r30		; :(((
 push	r31
 movw	r30, r26
 rcall	od_Print
 pop	r31
 pop	r30

 pop	r26

;    ( )

 tst	r26
 breq	mn_di_5
 clr	r27
 ld	r16, X
 andi	r16, 0x3F
 mov	r0, r16
 rcall	DecByteOut
mn_di_5:

;     

; ....

;
;  ,    Z (   ,   )
;
mn_Action:
 lsr	r31
 ror	r30
 ijmp

;
;  Z   ,   r16
; Z = 1,    ()
; T = 1,       (   Z = 0)
;
mn_Locate:
 movw	r30, r28
 ldi	r17, 0x0E	;   
 mul	r16, r17
 add	r30, r0
 adc	r31, r1

 lpm	r17, Z
 tst	r17
 bst	r17, 0
 ret
;;
;;   ,  - ,     
;;

;
;   , , 
;
M_Pic:
			; 0    od_Tab (D7..D1),     (D0)
			;   (      !)
			;    == 0 -    ,  			
			; 1  ,     
			; 2  ,    
			; 3    ,   & 0x3F   ( <> 0)
.db	0x20*3 + 0x01 + 0x02, GREEN+B_TRANS, B_GREEN, low(VDc10)
			;      <- ->
.dw	M_Pic_Txt1*2	; 4 ASCIIZ- 
 ret			; 6  ,    
 ret			; 8    
 ret			; a   OK
 ret			; c    

.db	0x20*4 + 0x01 + 0x02, GREEN+B_TRANS, B_GREEN, low(VDc12)
.dw	M_Pic_Txt2*2
 ret
 ret
 ret
 ret

.db	0x20*5 + 0x01 + 0x02, GREEN+B_TRANS, B_GREEN, low(VDc11)
.dw	M_Pic_Txt3*2
 ret
 ret
 ret
 ret

.db	0x20*7 + 0x01 + 0x02, YELLOW+B_TRANS, B_YELLOW, 0
.dw	M_Pic_Txt4*2
 ret
 ret
 rjmp	M_Pic_Save
 ret

.db	0	; Fin

M_Pic_Txt1:
 .db	0x0b, 0x1b, "Brightness: ", 0
M_Pic_Txt2:
 .db	0x0a, 0x1a, "Contrast  : ", 0
M_Pic_Txt3:
 .db		  "  Saturation: ", 0
M_Pic_Txt4:
 .db	"Set  as  default", 0

M_Pic_Save:
 ldi	r24, FLB_10_12
 lds	r4, VDc10
 lds	r5, VDc11
 lds	r6, VDc12
 rcall	f_Write

 ldi	r26, 0x20*7
 rcall	od_Tab
 ldi	r17, 0x3c
 rcall	od_CharOut
 rjmp	i_Stop

;
;   
;
M_Tuner:
 .db	0x20*2 + 0x01, WHITE+B_TRANS, B_WHITE, 0
 .dw	M_Tuner_Txt1*2
 rjmp	M_Tun_DivDraw
 rjmp	M_Tun_MoveLeft
 rjmp	tv_FineTuning
 rjmp	M_Tun_MoveRight

 .db	0x20*3 + 0x00, WHITE+B_TRANS, B_WHITE, 0
 .dw	M_Tuner_Txt2*2
 rjmp	M_Tun_FreqDraw
 ret
 ret
 ret

 .db	0x20*4 + 0x01, WHITE+B_TRANS, B_WHITE, 0
 .dw	M_Tuner_Txt3*2
 ret
 rjmp	tv_ScanDown
 rjmp	tv_FineTuning
 rjmp	tv_ScanUp

 .db	0x20*5 + 0x01, WHITE+B_TRANS, B_WHITE, 0
 .dw	M_Tuner_Txt4*2
 rjmp	M_Tun_SkipDraw
 rjmp	M_Tun_SkipChg
 rjmp	M_Tun_SkipChg
 rjmp	M_Tun_SkipChg

 .db	0x20*7 + 0x01 + 0x04, YELLOW+B_TRANS, B_YELLOW, 0
 .dw	M_Tuner_Txt5*2
 rjmp	M_Tun_CHDraw
 rjmp	M_Tun_CHDown
 rjmp	M_Tun_Save
 rjmp	M_Tun_CHUp

 .db	0

M_Tuner_Txt1:
 .db	"Multiplier: ", 0
M_Tuner_Txt2:
 .db	"Freq /MHz/: ", 0
M_Tuner_Txt3:
 .db	"Search ", 0x05, " ", 0x15, ": ", 0
M_Tuner_Txt4:
 .db	"Skip      : ", 0
M_Tuner_Txt5:
 .db	"Save to   : ", 0

M_Tun_DivDraw:
 lds	r16, TNDivL
 lds	r17, TNDivH
 cbr	r17, 0x80
 movw	r0, r16
 rjmp	DecWordOut
; 
M_Tun_MoveLeft:
 ldi	r23, -1
 rjmp	tv_TuneAndBandSwitch
;
M_Tun_MoveRight:
 ldi	r23, 1
 rjmp	tv_TuneAndBandSwitch
;
M_Tun_FreqDraw:
 lds	r16, TNDivL
 lds	r17, TNDivH
 cbr	r17, 0x80
 movw	r0, r16
 ldi	r16, 32
 clr	r17
 movw	r2, r16
 rcall	div16u		;      ,      

 ldi	r16, 38
 clr	r17
 sub	r0, r16
 sbc	r1, r17

 rjmp	DecWordOut	; TNDiv / 32 - 38
;
M_Tun_SkipDraw:
 lds	r16, TNDivH
 ldi	r17, 'Y'
 sbrs	r16, 7
 ldi	r17, 'N'
 rjmp	od_CharOut
;
M_Tun_SkipChg:
 lds	r16, TNDivH
 ldi	r17, 0x80
 eor	r16, r17
 sts	TNDivH, r16
 ret
;
M_Tun_CHDraw:
 lds	r0, CH_dst
 rjmp	DecByteOut
;
M_Tun_CHDown:
 lds	r16, CH_dst
 rcall	ch_Dec
 sts	CH_dst, r16
 ret
;
M_Tun_Save:
 rcall	ch_Save
 ldi	r26, 0x20*7
 rcall	od_Tab
 ldi	r17, 0x3c
 rjmp	od_CharOut
;
M_Tun_CHUp:
 lds	r16, CH_dst
 rcall	ch_Inc
 sts	CH_dst, r16
 ret

;
;  
;
M_Speed:
 .db	0x20*4 + 0x01, LBLUE+B_TRANS, B_LBLUE, 0
 .dw	M_Speed_Txt1*2
 rjmp	M_Speed_Draw
 rjmp	M_Speed_Down
 ret
 rjmp	M_Speed_Up

 .db	0
;
M_Speed_Txt1:
 .db	"Speed: ", 0
;
M_Speed_Draw:
 in	r0, OSCCAL
 rjmp	DecByteOut
;
M_Speed_Down:
 in	r16, OSCCAL
 dec	r16
 out	OSCCAL, r16
 ret
;
M_Speed_Up:
 in	r16, OSCCAL
 inc	r16
 out	OSCCAL, r16
 ret

;;==========================================================================
;;    +  
;;  r16, r17, r24, r25
;; Post codes:
;; 2 -    
;; 3 -   
;; 4 -    
;; 5 -      
;;

;
;   
;
pw_Off:
 cbi	roPower, pPower		;   
 cbi	roHeat1, pHeat1
 cbi	roHeat2, pHeat2

 cbi	roLight, pLight		;    

 ldi	r24, 4*3		;    3 
pw_OF_1:
 rcall	Wait250ms
 sbis	riPowerMon, pPowerMon
 ret
 dec	r24
 brne	pw_OF_1

 ldi	r24, 2			;    (  )
 rjmp	pw_Bell			; -   

;
;   
;
pw_On:
 ldi	r24, 3
 sbic	riHeatMon, pHeatMon	;   ,  
 rjmp	pw_Bell			;        - 3 

;   -    - 10 

 sbi	roHeat1, pHeat1
 ldi	r24, 10
pw_ON_1:
 cbi	roBell, pBell
 cbi	roLight, pLight
 rcall	Wait250ms
 sbi	roBell, pBell
 sbi	roLight, pLight
 rcall	Wait250ms
 rcall	Wait500ms
 dec	r24
 brne	pw_ON_1
 cbi	roHeat1, pHeat1

;   -    - 5 

 sbi	roHeat2, pHeat2
 ldi	r24, 5
pw_ON_2:
 cbi	roBell, pBell
 cbi	roLight, pLight
 rcall	Wait500ms
 sbi	roBell, pBell
 sbi	roLight, pLight
 rcall	Wait500ms
 dec	r24
 brne	pw_ON_2
 cbi	roHeat2, pHeat2

;  1/2  -      

 rcall	Wait500ms

;   

 sbi	roPower, pPower

;  1/2      

 rcall	Wait500ms

 ldi	r24, 4
 sbis	riPowerMon, pPowerMon
 rjmp	pw_Bell

;    -       ...

 ldi	r24, 5
 sbic	riHeatMon, pHeatMon	; ...  5 
 ret

;
;   ,    r24 
;    
;
pw_Bell:
 cbi	roPower, pPower		;   
 cbi	roHeat1, pHeat1
 cbi	roHeat2, pHeat2
 mov	r25, r24

pw_B_2:
 cbi	roBell, pBell
 rcall	Wait250ms
 sbi	roBell, pBell
 rcall	Wait250ms
 dec	r25
 brne	pw_B_2

 rcall	Wait500ms
 rcall	Wait500ms
 rcall	Wait500ms
 rcall	Wait500ms
 rjmp	pw_Bell

;
;   Bell
;
pw_BellChg:
 ldi	r17, (1<<pBell)
 in	r16, roBell
 eor	r16, r17
 out	roBell, r16
 ret

;;==========================================================================
;;  .   
;;

;   AT89   :
;     
; 0-1 -  
;   2 - D7 -  , D6 - AFC enable, D5-D4 - SYS, D3..D0 - 
; 3-4 -  , , 
; 5-7 -  
; SYS: 00 - auto, 01 - ntsc, 10 - pal, 11 - secam

;   ,  , :
; 0.7		- 1 - Skip channel
; 0.6..0.0,
; 1.7..1.0	-  
; 2.0..2.2	-   
; 

;
;      ( )
;
ch_GetDesc:
 lds	r24, CH_cur
 rjmp	f_Read

;
;   /
; "",       !
;
ch_Inc:
 inc	r16
 cpi	r16, CH_max
 brlo	ch_I_1
 clr	r16
ch_I_1:
 ret
;
ch_Next:
 lds	r16, CH_cur	;    
 rcall	ch_Inc
 sts	CH_cur, r16
 rcall	ch_GetDesc
 bst	r0, 7
 brts	ch_Next		;    'Skip' -  
 rjmp	ch_GoTo
;
ch_Dec:
 tst	r16
 brne	ch_D_1
 ldi	r16, CH_max
ch_D_1:
 dec	r16
 ret
;
ch_Prev:
 lds	r16, CH_cur	;    
 rcall	ch_Dec
 sts	CH_cur, r16
 rcall	ch_GetDesc
 bst	r0, 7
 brts	ch_Prev

;
;    CH_cur
;
ch_GoTo:
 rcall	ch_GetDesc

 mov	r16, r2
 andi	r16, 0x07		;  
 sts	TNCtl1, r16
 
 sts	TNDivH, r0		;  
 sts	TNDivL, r1

 rcall	v_MuteOn		;  

 rcall	t_Write			;  

 ldi	r16, GREEN
 rcall	ch_Tab

 lds	r0, CH_cur
 rcall	DecByteOut
 rcall	i_Stop

 rjmp	v_MuteRestore		;  

;
;  OSD     
;   r16  ODattr
;
ch_Tab:
 ldi	r26, 4*10		;      - 4 
 mov	Timer10b, r26
 
 ldi	r26, 0x20*2+16
 rjmp	od_Tab_Attr

;
;    ,  
;
ch_Save:
 lds	r24, CH_dst
 lds	r4, TNDivH
 lds	r5, TNDivL
 lds	r6, TNCtl1
 rjmp	f_Write

;;==========================================================================
;;     
;;     
;;  i2c [r16, r24, r25] 
;;     [r0..r2], r17, r23
;; ???????????? tv_Scan*   v_Write [X, Z] ??????????
;;

;
;       TNDiv
;
tv_ScanDown:
 ldi	r23, -20
 rjmp	tv_su_0

;
;       TNDiv
;
tv_ScanUp:
 ldi	r23, 20
tv_su_0:

 push	r23
 rcall	v_MuteOn
 pop	r23

 clt
 rcall	tv_FlowFreq		;    
 set
 rcall	tv_FlowFreq		;   
 rcall	tv_FineTuning		;    

 rjmp	v_MuteRestore

;
;     AFC   
;        / 
;
tv_FineTuning:
 rcall	tv_IsStation
 brcc	tv_FT_1			;    -   
 bst	rVD_AFA, pVD_AFA
 brts	tv_FT_1			; AFA == 1:    

 rcall	pw_BellChg

 ldi	r23, -1			;  ,   .   
 sbrc	rVD_AFB, pVD_AFB
 ldi	r23, 1

 rcall	tv_TuneAndBandSwitch
 brcs	tv_FineTuning
tv_FT_1:
 sbi	roBell, pBell
 ret

;
;      r23,  / 
; : T = 1 -    , T = 0 -     
;       -
;
tv_FlowFreq:
 rcall	tv_TuneAndBandSwitch
 brcc	tv_FF_1			;   
 
 rcall	pw_BellChg

 push	r23
 rcall	tv_IsStation
 pop	r23
 bld	r17, 7
 ror	r16
 eor	r16, r17		; C = C xor T
 rol	r16
 brcs	tv_FlowFreq
tv_FF_1:
 sbi	roBell, pBell
 ret

;
;     TNDiv + r23, ,   
; C = 0,            
;
;   ,  , 
;        :
; I:	0x09, 0x18,	II:	0x14, 0x3d,	III:	0x38, 0x71
;
;  :  .     ,  
;        ,
;         C = 0 [  ~39..960 ]
;     (  ): 0x12, 0x26, 0x57
;
;         ,
;           
; (,          ).
;  ,     ,     ,
;    ,       .
;
tv_TuneAndBandSwitch:
 mov	r16, r23

tv_TABS_4:
 rcall	t_Tune
 brcs	ret3

 lds	r16, TNDivH

 ldi	r17, 0x80
 cpi	r16, 0x12
 brlo	tv_TABS_2	; TNDivH < 0x12

 ldi	r17, 0x21
 cpi	r16, 0x26
 brlo	tv_TABS_2	; 0x12 =< TNDivH < 0x26

 ldi	r17, 0x42
 cpi	r16, 0x57
 brlo	tv_TABS_2	; 0x26 =< TNDivH < 0x57

 ldi	r17, 0x08	; 0x57 =< TNDivH

tv_TABS_2:
 sbrs	r23, 7		;       
 swap	r17
 andi	r17, 0x0F
 breq	ret_CC		; 0 -   C = 0 -  
 sbrc	r17, 3
 rjmp	ret_CS		; 8 -   C = 1 -    [  ,    ]
 sts	TNCtl1, r17	;  
; 		ldi	r25, '*'
;		rcall	SendByte
; 		mov	r25, r17
;		rcall	ByteOut
 clr	r16
 rjmp	tv_TABS_4

;
;       Video Ident
; C = 1,     
;
tv_IsStation:
 ldi	r23, 10			;       20 ms
				;   ,    4..6 ms
tv_IS_1:
 rcall	Wait2ms			;  : 2ms -  AGC increase, 10 ms -  Video Ident
 rcall	v_Read
 sbrc	rVD_IFI, pVD_IFI	; IFI == 0: Video  
 sbrs	rVD_SL, pVD_SL		; SL  == 0:   f1 -    AFA  AFB
 rjmp	tv_IS_2
ret_CS:
 sec				; IFI == SL == 1:  
ret3:
 ret

tv_IS_2:
 dec	r23
 brne	tv_IS_1
ret_CC:
 clc				;   
 ret

;;==========================================================================
;;  i2c
;;  r16, r24, r25 (Z ,  )
;; Prescaller = const = 00
;;

;
; 
;
i_Init:
 ldi	r16, twibr
 out	TWBR, r16
 ret
;
;  "Start"
;       Stop [ -     SDA = SCL ]
;  Z = 0   
;
i_Start:
 ldi	r16, (1<<TWINT) | (1<<TWSTA) | (1<<TWEN)
 out	TWCR, r16
 rjmp	i_WaitReady
;
;  "Stop"
;    -ɣ  [,  SCL  SDA    = 0 ]
; SREG   !!!
; ,     ATmega     ,
;     
;
i_Stop:
 ldi	r16, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
 out	TWCR, r16
 ret
;
; Send byte
;   r16,  C = 0    
; Z = 0    ( ̣   Z = 1).
; [ ,  , SCL = 0  ,  SDA = SCL = 0 ]
;
i_SendByte:
 out	TWDR, r16
 ldi	r16, (1<<TWINT) | (1<<TWEN)
 out	TWCR, r16
 rjmp	i_WaitReady
;
; Recv byte
;      C = 0, r16 -  
; Z = 0   
; [        SDA = SCL = 0 ]
;
i_RecvByte:
 ldi	r16, (1<<TWINT) | (1<<TWEN)
 brcs	i_RB_1
 ori	r16, (1<<TWEA)
i_RB_1:
 out	TWCR, r16
 rcall	i_WaitReady
 in	r16, TWDR
 ret
;
;   I2C
;   TWSR == 0   !!! [   ]
;    Z = 0     Z = 1 -  
;  Z = 1   C = 0   ACK  C = 1 -  NACK
;       i_Stop
;
i_WaitReady:
 in	r16, TWCR	; sbis	TWCR, TWINT
 sbrs	r16, TWINT
 rjmp	i_WaitReady

 in	r16, TWSR
 ldi	r24, 10
 push	r30
 push	r31
 ldi	r30, low(i_Table*2)
 ldi	r31, high(i_Table*2)

i_W_1:
 lpm	r25, Z+
 cp	r25, r16	; cpse may be ?
 breq	i_W_2
 dec	r24
 brne	i_W_1

 rcall	i_Stop
 rjmp	i_W_3
 
i_W_2:
 lsr	r24	;  C
 sez

i_W_3:
 pop	r31
 pop	r30
 ret

; "" .   - NACK
i_Table:
.db	0x08, 0x10,  0x18, 0x20, 0x28, 0x30,  0x40, 0x48, 0x50, 0x58

;;==========================================================================
;;   
;;  i2c [r16, r24, r25] 
;;     [VDs*: r0..r2], r17
;; v_Write      [r23, X, Z]
;;

;
;  v_ChangeVal,    
;   
;
v_ChangeVolume:
 rcall	v_ChangeVal		;  

 ldi	r16, 4*10		;     - 4 
 mov	Timer10b, r16

 ldi	r16, GREEN+B_TRANS	;  	
 ldi	r26, 0x20*7+4		;  
 rcall	od_Tab_Attr

 ldi	r30, low(v_CV_text*2)	;  
 ldi	r31, high(v_CV_text*2)
 rcall	od_Print

 ldi	r16, RED+B_TRANS	;  	
 sts	ODattr, r16

 lds	r16, VDc14		; 
 andi	r16, 0x3F
 mov	r0, r16
 rcall	DecByteOut

 rjmp	i_Stop			;  i2c
;
v_CV_text:
 .db	"Volume: ", 0
;
;   ""    .
; r26   low(register), ,    < 0x80 
; r16.7 -  
;
v_ChangeVal:
 bst	r26, 7		; T = 0 - ++, T = 1 - --
 cbr	r26, 0x80
 clr	r27

 ld	r16, X
 mov	r17, r16
 brts	v_CV_1
 com	r16
v_CV_1:
 andi	r16, 0x3F
 breq	ret8
 inc	r17
 brtc	v_CV_2
 subi	r17, 2
v_CV_2:
 st	X, r17
 rjmp	v_Write

;
;   Sound Mute
;
v_MuteOff:		;  
 lds	r16, VDc14
 cbr	r16, 0x80
 rjmp	v_mo_1
;
v_MuteOn:		;       
 lds	r16, VDc14
 sts	VDc14a, r16
 sbr  	r16, 0x80
 rjmp	v_mo_1
;
v_MuteRestore:		;   
 rcall	Wait250ms
 clr	IRRecv		; MuteRestore     ,
			;         
 lds	r16, VDc14a
 rjmp	v_mo_1
;
v_MuteChg:		;   
 lds	r16, VDc14
 ldi	r24, 0x80
 eor	r16, r24

v_mo_1:
 sts	VDc14, r16
 rjmp	v_Write
;
;     (ROM -> VDc*)
;
v_InitVal:
 ldi	r30, low(v_itable*2)	; Z
 ldi	r31, high(v_itable*2)
 ldi	r26, low(VDc)		; X
 ldi	r27, high(VDc)

 ldi	r23, VDcCNT

v_i_1:
 lpm	r16, Z+
 st	X+, r16
 dec	r23
 brne	v_i_1
ret8:
 ret
;
;    [],  v_Write
;    v_InitVal
;
v_InitHard:
 rcall	v_Read
 sbrc	rVD_POR, pVD_POR
 rjmp	v_InitHard
;
;      VDc*
;
v_Write:
 ldi	r30, low(v_atable*2)	; Z
 ldi	r31, high(v_atable*2)
 ldi	r26, low(VDc)		; X
 ldi	r27, high(VDc)

 ldi	r23, VDcCNT

v_w_1:
 lpm	r17, Z+
 rcall	v_SetAddr

 ld	r16, X+
 rcall	i_SendByte
 brne	v_Write		;  
 brcs	v_Write		; NASK

 dec	r23
 brne	v_w_1

 rjmp	i_Stop

;   

v_atable:
.db	0x00, 0x01, 0x02, 0x03
.db	0x08, 0x09, 0x0a, 0x0b
.db	0x0c, 0x0d, 0x0e, 0x0f
.db	0x10, 0x11, 0x12, 0x13
.db	0x14, 0x15
.db	0x18, 0x19, 0x1a, 0x1b

;   

v_itable:
.db	0x03, 0xd0, 0xe0, 0x20
.db	0x20, 0xe0, 0x20, 0x20
.db	0x20, 0x20, 0x20, 0x20
.db	0x27, 0xa0, 0x08, 0x00
.db	0x10, 0x60
.db	0x00, 0x00, 0x00, 0x00
;
;     r0..r2
;
v_Read:
 clr	r17		;    ,    
 rcall	v_SetAddr	;   Start,       
			;  POR = 0
 rcall	i_Start
 ldi	r16, 0x8B
 rcall	i_SendByte
 brne	v_Read		;  
 brcs	v_Read		; NASK

 clc
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs0, r16

 clc
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs1, r16

 sec
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs2, r16

 rjmp	i_Stop

;     [ r17]

v_SetAddr:
 rcall	i_Start
 ldi	r16, 0x8A
 rcall	i_SendByte
 brne	v_SetAddr	;  
 brcs	v_SetAddr	; NASK

 mov	r16, r17
 rcall	i_SendByte
 brne	v_SetAddr	;  
 brcs	v_SetAddr	; NASK
 ret

;;==========================================================================
;; TUNER interface
;;  i2c [r16, r24, r25], r17
;;

;
;    r16 () + TNDiv,
;    (FL = 1)  C = 1
;
t_Tune:
 clr	r17
 sbrc	r16, 7
 com	r17
t_t_1:
 lds	r24, TNDivL
 add	r16, r24
 sts	TNDivL, r16
 lds	r25, TNDivH
 adc	r17, r25
 sts	TNDivH, r17

 rcall	t_Write

 ldi	r17, 250	;  500 .   ,   150 
t_t_2:			;   dx = 1  t ~ 2..4 ms,  dx = 20  t ~ 8 ms
 rcall	Wait2ms		;      , , 158 ms
 rcall	t_Read
 dec	r17
 sbrs	r25, 6
 brne	t_t_2
 rol	r25
 rol	r25
 ret 
;
;    
;
t_Write:
 rcall	i_Start
 ldi	r16, 0xC0
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNDivH
 cbr	r16, 0x80
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNDivL
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNCtl0
 sbr	r16, 0x80
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNCtl1
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK
 
 rjmp	i_Stop
;
;      r25
;
t_Read:
 rcall	i_Start
 ldi	r16, 0xC1
 rcall	i_SendByte
 brne	t_Read		;  
 brcs	t_Read		; NASK
 sec
 rcall	i_RecvByte
 brne	t_Read
 mov	r25, r16
 rjmp	i_Stop

;;==========================================================================
;; OnScreenDisplay interface
;;  i2c [r16, r24, r25], X
;; od_ClrScr  od_Init   r17  Z
;;

;
;  OSD
;
od_Init:
 ldi	r30, low(od_Table*2)
 ldi	r31, high(od_Table*2)

 ldi	r26, 0xF0	;   
 ldi	r27, 0x3F
 ldi	r17, 8
 rcall	od_i_2

 clr	r26		;   
 clr	r27
 ldi	r17, 18
;
od_i_2:
 rcall	od_SetAddr
od_i_1:
 lpm	r16, Z+
 rcall	i_SendByte
 brne	od_Init		;  
 brcs	od_Init		; NASK
 dec	r17
 brne	od_i_1
 rjmp	i_Stop
;
od_Table:
.db	0x20, 0x14, 0x24, 0x90, 0x22, 0x33, 0xE0, 0x05

.db	0x16, 0x00		; Spacing -   VSync   
.db	0x40, 0xC0		; 0- 
.db	0x80, 0xC0		; 1- 
.db	0xC0, 0xC0		; 2- 
.db	0x00, 0xC1		; 3- 
.db	0x40, 0xC1		; 4- 
.db	0x80, 0xC1		; 5- 
.db	0xC0, 0xC1		; 6- 
.db	0x14, 0x00		; Spacing -     6- 

;
;  
;
od_ClrScr:
 ldi	r16, B_TRANS		;  ,  
 ldi	r26, 0x20		;  ,  
 rcall	od_Tab_Attr
 ldi	r30, 32*7

od_cs_1:
 rcall	od_SpaceOut
 dec	r30
 brne	od_cs_1

 ldi	r16, -2			;       -    
 mov	Timer10b, r16		; (       , )
 rjmp	i_Stop

;
;   r17   ODattr.    od_Tab,    i_Stop
;  i2c   !!! [SetAddr      ,      ]
;
od_SpaceOut:
 ldi	r17, ' '
;
od_CharOut:
 lds	r16, ODattr
 rcall	i_SendByte

 mov	r16, r17
 cpi	r16, ' '
 brne	od_CO_1
 ldi	r16, 0x80+63	;   stv9425   
od_CO_1:
 rjmp	i_SendByte

;
;   ASCIZ,    Z,  od_CharOut
;   D7 = 1   ODattr,  D3 -> D7, 0 -> D3
;
od_Print:
 lpm	r17, Z+
 tst	r17
 breq	ret9
 brmi	od_P_1
 rcall	od_CharOut
 rjmp	od_Print
;
od_P_1:
 bst	r17, 3		;        ,
 bld	r17, 7		;          ,
 clt			;         .
 bld	r17, 3		;       -    -   .
 sts	ODattr, r17
 rjmp	od_Print
 
;
;   (   OSD)    r26   
; D7..D5 -   (1..6), D4..D0 -   (0..21)
;
od_Tab_Attr:
 sts	ODattr, r16
;
od_Tab:
 clr	r27
 lsl	r26
 rol	r27

;
;     OSD  X
;
od_SetAddr:
 rcall	i_Start
 ldi	r16, 0xBA
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK

 mov	r16, r26
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK

 mov	r16, r27
 andi	r16, 0x3F
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK
ret9:
 ret

;;==========================================================================
;;      (EEPROM)
;;   , 128   4  
;;  r16, r24, r25, r0-r7, X
;;

;
;   r24   r0, r1, r2, r3
;
f_Read:
 rcall	f_CalcAddr
 rcall	f_WWait

 out	EEARH, r25
 clr	r26
 clr	r27
 rcall	f_GetByte
 rcall	f_GetByte
 rcall	f_GetByte
;
;   ,   (X)
;
f_GetByte:
 out	EEARL, r24
 inc	r24

 sbi	EECR, EERE
 in	r16, EEDR
 st	X+, r16
 ret
;
;    (r24:r25)    (r24)
;
f_CalcAddr:
 clr	r25
 lsl	r24
; rol	r25
 lsl	r24
 rol	r25
 ret
;
;   
;         sleep modes !
;
f_WWait:
 sbic	EECR, EEWE
 rjmp	f_WWait
 ret
;
;   r24  r4, r5, r6, r7
;
f_Write:
 rcall	f_CalcAddr
 ldi	r26, 4
 clr	r27

 rcall	f_PutByte
 rcall	f_PutByte
 rcall	f_PutByte
;
;     (X)
;
f_PutByte:
 rcall	f_WWait

 out	EEARH, r25
 out	EEARL, r24
 inc	r24

 ld	r16, X+
 out	EEDR, r16
 cli			;        -   ...
 sbi	EECR, EEMWE	; ...   
 sbi	EECR, EEWE
 sei
 ret

;;==========================================================================
;; 
;;  r0..r7, r16, r17 + od_CharOut
;;

;* Title:		Multiply and Divide Routines
;* Version:		1.1
;* Last updated:	97.07.04
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor).
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;*
;***************************************************************************
; input:	r1, r0 = Dividend X
; 		r3, r2 = Divisor Y
;
; output:	r1, r0 = quotient Q of division
;		r7, r6 = remainder
;
; r1:r0 / r3:r2 = r1:r0 [r7:r6]		Q = X / Y
;
;***** Subroutine Register Variables

.def	dd16uL	= r0
.def	dd16uH	= r1
.def	dv16uL	= r2
.def	dv16uH	= r3

.def	dres16uL= r0
.def	dres16uH= r1
.def	drem16uL= r6
.def	drem16uH= r7

.def	dcnt16u	= r16

;***** Code

div16u:	clr	drem16uL		;clear remainder Low byte
	sub	drem16uH, drem16uH	;clear remainder High byte and carry
	ldi	dcnt16u, 17		;init loop counter
d16u_1:	rol	dd16uL			;shift left dividend
	rol	dd16uH
	dec	dcnt16u			;decrement counter
	brne	d16u_2			;if done
	ret				; return
d16u_2:	rol	drem16uL		;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL, dv16uL	;remainder = remainder - divisor
	sbc	drem16uH, dv16uH
	brcc	d16u_3			;if result negative
	add	drem16uL, dv16uL	; restore remainder
	adc	drem16uH, dv16uH
	clc				; clear carry to be shifted into result
	rjmp	d16u_1			;else
d16u_3:	sec				; set carry to be shifted into result
	rjmp	d16u_1

;
;       dd16uL:dd16uH
;  od_CharOut     
;
DecByteOut:
 clr	r1
DecWordOut:
 ldi	r16, 10
 mov	dv16uL, r16
 clr	r16
 push	r16
 mov	dv16uH, r16

dwo_1:
 rcall	div16u

 ldi	r16, '0'
 add	drem16uL, r16
 push	drem16uL

; movw	dd16uL, dres16uL	; NB: @dd == @dres !

 mov	r16, dd16uL
 or	r16, dd16uH
 brne	dwo_1

dwo_2:
 pop	r17
 tst	r17
 breq	dwo_3
 rcall	od_CharOut
 rjmp	dwo_2

dwo_3:
 rjmp	od_SpaceOut		;       

;;==========================================================================
;; 
;;

;
; About
; -,      ,   ߣ      .
;
About:
 rcall	mn_Off

 ldi	r26, 0x20*4+1
 rcall	od_Tab
 ldi	r30, low(About_Txt0*2)
 ldi	r31, high(About_Txt0*2)
 rcall	od_Print

 ldi	r26, 0x20*6+1
 rcall	od_Tab
 ldi	r30, low(About_Txt2*2)
 ldi	r31, high(About_Txt2*2)
 rcall	od_Print

 ldi	r16, 4*10
 mov	Timer10b, r16

 rjmp	i_Stop
;
About_Txt0:
 .db	LBLUE+(B_TRANS>>4)+0x80, "Ravodin  ", YELLOW+(B_TRANS>>4)+0x80, "V0.1m 2007", 0
About_Txt2:
 .db	BLACK+B_BLUE+0x80, "deka/at/inet.tsu.ru", 0
