; - : i2c, com-,  IR, internal FLASH, ADC, manual sleep

.nolist
.include "/usr/local/include/avr/m8def.inc"
.list

; :
; r0..r3	- Flash, VideoCPU, Math
; r4..r7	- Flash, Math
; r8..r11	- Interrupt Ext0
; r12
; r8, r13..r15	- Interrupt Timer
; r16		- _all_
; r17		- VideoCPU
; r18..r21	- Interrupt Ext0
; r22		- ?
; r23		- VideoCPU, Tuner&Video, Syntax Analyser
; r24..r25	- i2c, _all_
; r26..r31	- _all_ [X, Y, Z]

;
;  OSD
;
.equ	BLACK		= 0		;   OSD
.equ	RED		= 4
.equ	BLUE		= 1
.equ	GREEN		= 2
.equ	YELLOW		= GREEN+RED
.equ	LBLUE		= GREEN+BLUE
.equ	WHITE		= GREEN+RED+BLUE

.equ	B_TRANS		= 0x80		;   OSD
.equ	B_BLACK		= 0x00
.equ	B_RED		= 0x40
.equ	B_BLUE		= 0x10
.equ	B_GREEN		= 0x20
.equ	B_YELLOW	= B_GREEN+B_RED
.equ	B_LBLUE		= B_GREEN+B_BLUE
.equ	B_WHITE		= B_GREEN+B_RED+B_BLUE

.equ	MAXX		= 32		;     (   - 22)
.equ	MAXY		= 7		;  

;
;   
;
.equ	usartdiv	= 12		;  USART ~38.400 b/s  8  
.equ	twibr		= 32		;  TWI 100   8   [ sclf = mainf / (16+2(twbr)*(4^twps)) ]
.equ	rtctop		= 12500-1	;    1   10     prescaler == 64   8 

;
;   
;
.def	VDs0		= r0
.def	VDs1		= r1
.def	VDs2		= r2
;
.def	rVD_POR		= VDs0
.equ	pVD_POR		= 7
.def	rVD_FSI		= VDs0
.equ	pVD_FSI		= 6
.def	rVD_SL		= VDs0
.equ	pVD_SL		= 4
.def	rVD_XPR		= VDs0
.equ	pVD_XPR		= 3
.def	rVD_CD2		= VDs0
.equ	pVD_CD2		= 2
.def	rVD_CD1		= VDs0
.equ	pVD_CD1		= 1
.def	rVD_CD0		= VDs0
.equ	pVD_CD0		= 0

.def	rVD_NDF		= VDs1
.equ	pVD_NDF		= 7
.def	rVD_IN1		= VDs1
.equ	pVD_IN1		= 6
.def	rVD_IFI		= VDs1
.equ	pVD_IFI		= 4
.def	rVD_AFA		= VDs1
.equ	pVD_AFA		= 3
.def	rVD_AFB		= VDs1
.equ	pVD_AFB		= 2
.def	rVD_SXA		= VDs1
.equ	pVD_SXA		= 1
.def	rVD_SXB		= VDs1
.equ	pVD_SXB		= 0

.def	rVD_N2		= VDs2
.equ	pVD_N2		= 7
.def	rVD_BCF		= VDs2
.equ	pVD_BCF		= 5
.def	rVD_IVW		= VDs2
.equ	pVD_IVW		= 4
.def	rVD_ID3		= VDs2
.equ	pVD_ID3		= 3
.def	rVD_ID2		= VDs2
.equ	pVD_ID2		= 2
.def	rVD_ID1		= VDs2
.equ	pVD_ID1		= 1
.def	rVD_ID0		= VDs2
.equ	pVD_ID0		= 0

;
; IO-
;
.equ	riIRInput	= PIND		; <- -			!!! NB:    -
.equ	roIRInput	= PORTD		;    pull-up
.equ	pIRInput	= 2

.equ	riHeatMon	= PIND		; <-   , 0 -  
.equ	roHeatMon	= PORTD		;   pullup
.equ	pHeatMon	= 6

.equ	rdHeat1		= DDRB		; ->   , 1 - 
.equ	roHeat1		= PORTB
.equ	pHeat1		= 1

.equ	rdHeat2		= DDRB		; ->   , 1 - 
.equ	roHeat2		= PORTB
.equ	pHeat2		= 2

.equ	rdPower		= DDRB		; ->  , 1 - 
.equ	roPower		= PORTB
.equ	pPower		= 3

.equ	rdBell		= DDRB		; -> , 0 - 
.equ	roBell		= PORTB
.equ	pBell		= 4

.equ	riPowerMon	= PINB		; <-   , 1 -  
.equ	pPowerMon	= 5

					; ADC2 [PC2] - AGC monitor


.equ	rdLight		= DDRC		; -> , 1 - 
.equ	roLight		= PORTC
.equ	pLight		= 3

;
;   
;
.dseg

.equ	LineMax	= 32			;    
LineBuf:	.byte	LineMax		;   

DataSpacePtr:	.byte	2
EPROMSpacePtr:	.byte	1
VideoCPUReg:	.byte	1
IRDelay1:	.byte	1
IRDelay2:	.byte	1
OSDAddrPtr:	.byte	2
ODattr:		.byte	1


VDc14a: .byte	1	;  VDc14    

.equ	VDcCNT	= 22	;    
VDc:			;   
VDc00:	.byte	1
VDc01:	.byte	1
VDc02:	.byte	1
VDc03:	.byte	1

VDc08:	.byte	1
VDc09:	.byte	1
VDc0a:	.byte	1
VDc0b:	.byte	1

VDc0c:	.byte	1
VDc0d:	.byte	1
VDc0e:	.byte	1
VDc0f:	.byte	1

VDc10:	.byte	1
VDc11:	.byte	1
VDc12:	.byte	1
VDc13:	.byte	1

VDc14:	.byte	1
VDc15:	.byte	1

VDc18:	.byte	1
VDc19:	.byte	1
VDc1a:	.byte	1
VDc1b:	.byte	1


TNDivL:	.byte	1	;   
TNDivH:	.byte	1
TNCtl0:	.byte	1	;   
TNCtl1:	.byte	1



.cseg

.org	0x000
 rjmp	RESET		; Reset Handler
 rjmp	EXT_INT0	; IRQ0 Handler
 rjmp	EXT_INT1	; IRQ1 Handler
 rjmp	TIM2_COMP	; Timer2 Compare Handler
 rjmp	TIM2_OVF	; Timer2 Overflow Handler
 rjmp	TIM1_CAPT	; Timer1 Capture Handler
 rjmp	TIM1_COMPA	; Timer1 CompareA Handler
 rjmp	TIM1_COMPB	; Timer1 CompareB Handler
 rjmp	TIM1_OVF	; Timer1 Overflow Handler
 rjmp	TIM0_OVF	; Timer0 Overflow Handler
 rjmp	SPI_STC		; SPI Transfer Complete Handler
 rjmp	USART_RXC	; USART RX Complete Handler
 rjmp	USART_UDRE	; UDR Empty Handler
 rjmp	USART_TXC	; USART TX Complete Handler
 rjmp	ADCR		; ADC Conversion Complete Handler
 rjmp	EE_RDY		; EEPROM Ready Handler
 rjmp	ANA_COMP	; Analog Comparator Handler
 rjmp	TWSI		; Two-wire Serial Interface
 rjmp	SPM_RDY		; Store Program Memory Ready

;;==========================================================================
;;    # 0 - IR
;;  r8, r9, r10 [IRData], r11 [IRRecv], r18, r19, r20, r21
;;
.equ	IRPort	= riIRInput
.equ	IRBit	= pIRInput
.def	IRData	= r10		;      | 0x80 -   
.def	IRRecv	= r11		;   IRData
;
EXT_INT0:
 in	r8, SREG

;   
;    ,    

 clr	r19
INT0_0:
 inc	r19
 rcall	INT0_IRTest
 brcc	INT0_0

 subi	r19, 76		;     7800 ...
 brlo	INT0_2		; ...  

;   
;     

 clr	r19
INT0_1:
 inc	r19
 breq	INT0_2		;     -  
 rcall	INT0_IRTest
 brcs	INT0_1

 subi	r19, 26-1	;    ~3600   ~1700 
 brlo	INT0_4		;  ""

;   -  

 rcall	INT0_RecvDByte
 brcc	INT0_2		;  ɣ
 cpi	r21, 0x04
 brne	INT0_2		;     0x04
 rcall	INT0_RecvDByte
 brcc	INT0_2		;  ɣ
 rjmp	INT0_5

INT0_4:
 sbrc	Timer10a, 7
 rjmp	INT0_2
 mov	r21, IRData
 ori	r21, 0x80

INT0_5:
 mov	IRData, r21
 clr	IRRecv
 com	IRRecv
 ldi	r19, 5
 mov	Timer10a, r19	;          -
			;  ""   
INT0_2:
 out	SREG, r8
 reti

;   IR  ,     
; C = 0   
;  r9, r18, r19, r20,   r21  r9

INT0_RecvDByte:
 rcall	INT0_RecvByte
 brcc	INT0_RDB_ret
 mov	r9, r21
 rcall	INT0_RecvByte
 brcc	INT0_RDB_ret
 com	r21		; ! r21, c == 1
 cpse	r9, r21		; skip 'clc' if r9 == r21
 clc
INT0_RDB_ret:
 ret

;   IR 
; C = 0   timeout'a
;  r18, r19, r20,   r21

INT0_RecvByte:
 clr	r21
 ldi	r19, 8

INT0_RB_0:
 rcall	INT0_IRTest
 brcc	INT0_RB_0	;  -"1"

 ldi	r20, 15		;   1600  (    1500,
			; ,    ATmeg'  )
;lds	r20, IRDelay2
INT0_RB_1:		;   
 rcall	INT0_IRTest
 brcc	INT0_RB_2	;  
 dec	r20
 brpl	INT0_RB_1	;   15  0 
 clc
 ret

INT0_RB_2:		; C = 0
 sbrs	r20, 3		;    800  -  "0"	(F-[C,D], F-[1,2])
 sec
 ror	r21
;		st	Z+, r20
;		mov	irrecv, r20

 dec	r19
 brne	INT0_RB_0
 sec
 ret

;  5    100 ,  C = 0     IR = 0
;  r18

INT0_IRTest:
 sec
 ldi	r18, 5

INT0_IRT_0:
 rcall	Wait20mks
 sbis	IRPort, IRBit
 clc
 dec	r18
 brne	INT0_IRT_0

 ret

;
;
;
EXT_INT1:
TIM2_COMP:
TIM2_OVF:
TIM1_CAPT:
rjmp RESET

;;==========================================================================
;;    10 
;;  r8,  ģ  r13, r14, r15 -    1,   -1.
;;
.def	Timer10a	= r13	;      IR
.def	Timer10b	= r14
.def	Timer10c	= r15
;
TIM1_COMPA:
 in	r8, SREG
 sbrs	Timer10a, 7
 dec	Timer10a
 sbrs	Timer10b, 7
 dec	Timer10b
 sbrs	Timer10c, 7
 dec	Timer10c
 out	SREG, r8
 reti

;
;
;
TIM1_COMPB:
TIM1_OVF:
TIM0_OVF:
SPI_STC:
USART_RXC:
USART_UDRE:
USART_TXC:
ADCR:
EE_RDY:
ANA_COMP:
TWSI:
SPM_RDY:
rjmp RESET

;;==========================================================================
;;     
;;     sizeof(PC) = 16
;;

;
;   500  250 
;  r16, r17
;
Wait500ms:
 rcall	Wait250ms
Wait250ms:
 ldi	r17, 125
W_2:
 rcall	Wait2ms
 dec	r17
 brne	W_2
 ret
;
;   2  ~= 163  * 98
;  r16
;
Wait2ms:
 ldi	r16, 98
W_1:
 rcall	Wait20mks	; 160
 dec	r16		; 1
 brne	W_1		; 2
 ret
;
Wait20mks:		; 3	8*20 = 160
 rcall	Wait5mks	; 40
 rcall	Wait5mks	; 40
 rcall	Wait5mks	; 40	+ 37
;
Wait5mks:		; 3	40  = 5 
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8
 rcall	Wait1mks	; 8	+ 5
;
Wait1mks:		; 3	8    8  = 1 
 nop			; 1
 ret			; 4

;;==========================================================================
;;  
;;
RESET:				; Main program start
 ldi	r16, high(RAMEND)
 out	SPH, r16		; Set Stack Pointer to top of RAM
 ldi	r16, low(RAMEND)
 out	SPL, r16

;
;     pullup'
;

 ldi	r16, (1<<pIRInput) | (1<<pHeatMon)	; PortD, PullUp
 out	roIRInput, r16

 ldi	r16, (1<<pHeat1) | (1<<pHeat2) | (1<<pPower) | (1<<pBell)
 out	rdHeat1, r16

 sbi	roBell, pBell

; ldi	r16, (1<<pLight)
; out	rdLight, r16
 sbi	rdLight, pLight

;
;  USART
;

 ldi	r16, high(usartdiv)	; Speed
 out	UBRRH, r16          	; &UBRRH == &UBSRC:         [URSEL]: D7 = 1 -> UCSRC, D7 = 0 -> UBRRH
 ldi	r16, low(usartdiv)	; Speed
 out	UBRRL, r16

 ldi	r16, (1<<RXEN) | (1<<TXEN)
 out	UCSRB, r16
 
; ldi	r16, (1<<URSEL) | (3<<UCSZ0)	; By default    
; out	UCSRC, r16

;
;   0
;

; out TCCR1A, 0x00	; By default

 ldi	r16, (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (1<<CS11) | (1<<CS10)
 out	TCCR1B, r16

 ldi	r16, high(rtctop)
 out	OCR1AH, r16
 ldi	r16, low(rtctop)
 out	OCR1AL, r16

 ldi	r16, (1<<OCIE1A)
 out	TIMSK, r16

;
;  ,   
;

 ldi	r16, (1<<INT0)
 out	GICR, r16
 sei

;
;  i2c
;

 rcall	i_Init

;
;  RAM-  VideoCPU
;

 rcall	v_InitVal

;
;  OSD
;     
;
; rcall	od_Init
; rcall	od_ClrScr

;
;
;
Main:
 rcall	print
.db	12, "rs232 <-> i2c bridge ready !", 13, 1

m2:
 rcall	EnterString
 rcall	AnalyseString
 rjmp	m2

;;==========================================================================
;; rs232 -
;;  Z, r24:r25
;;

;
;   rs232 ascii-   0x01,      
;     sizeof(PC) == 16 !!!
;
print:
 pop	r31	; high
 pop	r30	; low
 lsl	r30
 rol	r31

p_2:
 lpm	r25, Z+
 cpi	r25, 1		;      EOL == 1,  
 breq	p_1		;  .db "  " \\ .db " "
 rcall	SendByte	;        ,  
 rjmp	p_2		;   ASCIZ.

p_1:
 adiw	r30, 1
 lsr	r31
 ror	r30
 ijmp
;
;   rs232   r24:r25
;
WordOut:
 rcall	ByteOut
 mov	r25, r24
;
;   rs232   r25
;
ByteOut:
 push	r25
 swap	r25
 rcall	HexOut
 pop	r25
;
;   rs232   r25
;
HexOut:
 andi	r25, 0x0F
 cpi	r25, 10	; c = 1 if r25 < 10
 brlo	ho_1	; BRanch if LOwer = BR ==== BRanch if C Set
; ldi	r24, 'A'-'0'-10
; add	r25, r24
 subi	r25, -('A'-'0'-10)
ho_1:
; ldi	r24, '0'
; add	r25, r24
 subi	r25, -('0')
;
; r25 -> rs232
;
SendByte:
			; Wait for empty transmit buffer
 sbis	UCSRA, UDRE	;  ,    [DataRegisterEmpty, TransmitComplete]
 rjmp	SendByte
 out	UDR, r25
 ret
;
; rs232 -> r25
;
RecvByte:
	 tst	IRRecv
	 breq	RB_1
	 mov	r25, IRData
	 rcall	ByteOut
;		 mov	r25, r30
;		 rcall	ByteOut
;		 ldi	r30, 0	- Z -    EnterString.    X
;		 ldi	r31, 1
	 ldi	r25, ' '
	 rcall	SendByte
	 clr	IRRecv
	RB_1:
 sbis	UCSRA, RXC	; Wait for data to be received [ControlStatusRegisterA]
 rjmp	RecvByte
 in	r25, UDR
 ret
;
;    LineBuf
;
.def	Cursor	= r24
.def	Char	= r25
;
EnterString:
 ldi	Char, '*'
 rcall	SendByte
 ldi	r30, low(LineBuf)
 ldi	r31, high(LineBuf)
 clr	Cursor
es_1:
 rcall	RecvByte
 st	Z, Char
 cpi	Char, 32
 brlo	es_2

;  
 cpi	Cursor, LineMax-1
 brsh	es_1
 inc	Cursor
 adiw	r30, 1
 rcall	SendByte
 rjmp	es_1

es_2:
 cpi	Char, 8
 brne	es_3

; BackSpace
 tst	Cursor
 breq	es_1

 rcall	SendByte
 ldi	r25, 32
 rcall	SendByte
 ldi	r25, 8
 rcall	SendByte

 dec	Cursor
 subi	r30, 1
 brcc	es_1
 subi	r31, 1
 rjmp	es_1

es_3:
 cpi	Char, 13
 brne	es_1

; Enter
 rjmp	SendByte

;;==========================================================================
;;  
;;  r23, r24:r25, Y
;;

;
;  .    (Y)
;  ascii.hex -> r24:25.    -> C = 1,  r24:r25  
;
Str2Val:
 rcall	Char2Val
 brcc	cv_ret
 mov	r24, r23
 clr	r25

sv_1:
 rcall	Char2Val
 brcc	cv_sec_ret
 lsl	r24
 rol	r25
 lsl	r24
 rol	r25
 lsl	r24
 rol	r25
 lsl	r24
 rol	r25
 or	r24, r23
 rjmp	sv_1
;
;   (Y) - hex- -> C = 1, Y++, r23 - value
;
Char2Val:
 ld	r23, Y
 subi	r23, '0'
 brlo	cv_1
 cpi	r23, 10
 brlo	cv_2
 subi	r23, 'A'-'0'
 cbr	r23, 0x20
 brlo	cv_1
 cpi	r23, 6
 brlo	cv_3

cv_1:
 clc
cv_ret:
 ret

cv_3:
 subi	r23, -(10)
cv_2:
 adiw	r28, 1
cv_sec_ret:
 sec
 ret
;
;  .           
;      ,  r28:r29 [Y] -       
;
as_Table:
.db	's', 0
.dw	cmd_Start
.db	'p', 0
.dw	cmd_Stop
.db	'g', 0
.dw	cmd_Get
.db	'G', 0
.dw	cmd_GetWithoutACK
.db	't', 0
.dw	cmd_Transmit

.db	'w', 0
.dw	cmd_WFlash
.db	'r', 0
.dw	cmd_RFlash

.db	'q', 0
.dw	cmd_WTuner
.db	'z', 0
.dw	cmd_RTuner
.db	'x', 0
.dw	cmd_TTuner

.db	'i', 0
.dw	cmd_IVideo
.db	'o', 0
.dw	cmd_RVideo
.db	'v', 0
.dw	cmd_WVideo

.db	'k', 0
.dw	cmd_SUp
.db	'j', 0
.dw	cmd_AFC
.db	'l', 0
.dw	cmd_SDown

.db	'|', 0
.dw	cmd_IOSD
.db	'[', 0
.dw	cmd_ROSD
.db	']', 0
.dw	cmd_WOSD
.db	'>', 0
.dw	cmd_ClrScr
.db	'<', 0
.dw	cmd_Print

.db	'{', 0
.dw	cmd_Power_On
.db	'}', 0
.dw	cmd_Power_Off

.db	'm', 0
.dw	cmd_RDataSpace
.db	'=', 0
.dw	cmd_ADC
.db	'@', 0
.dw	cmd_IRDelaySet
.db	'.', 0
.dw	cmd_Ports
.db	'-', 0
.dw	cmd_Sleep

.db	'?', 0
.dw	cmd_Help
.db	13, 0
.dw	cmd_Break

.db	0
;
AnalyseString:
 ldi	r28, low(LineBuf)
 ldi	r29, high(LineBuf)

as_1:
 ldi	r30, low(as_Table*2)
 ldi	r31, high(as_Table*2)
 ld	r25, Y+
 rcall	SendByte

as_2:
 lpm	r24, Z
 tst	r24
 breq	as_4

 cp	r24, r25	; cpse may be ?
 breq	as_3
 adiw	r30, 4
 rjmp	as_2

;     

as_4:
 ldi	r25, 7
 rcall	SendByte
 ldi	r25, '?'
 rcall	SendByte
 rjmp	as_1

;   !   -

as_3:
 adiw	r30, 2
 lpm	r24, Z+
 lpm	r25, Z+
 movw	r30, r24
; mov	r30, r24
; mov	r31, r25
 icall
 rjmp	as_1

;;
;;    i2c
;;
cmd_Start:
 rcall	i_Start

cmd_s_2:
 ldi	r25, '+'
 breq	cmd_S_1
 ldi	r25, '-'
cmd_S_1:
 rjmp	SendByte
;
cmd_Stop:
 rjmp	i_Stop
;
cmd_GetWithoutACK:
 sec
 rjmp	cmd_G_1
;
cmd_Get:
 clc
cmd_G_1:
 rcall	i_RecvByte
 rcall	cmd_s_2
 mov	r25, r16
 rjmp	ByteOut
;
cmd_Transmit:
 rcall	Str2Val
 brcc	cmd_T_ret
 mov	r16, r24
 rcall	i_SendByte
 in	r24, SREG
 rcall	cmd_s_2
 out	SREG, r24
 brcc	cmd_T_ret
 ldi	r25, 'N'
 rcall	SendByte
;
cmd_T_ret:
 ret

;;
;;   /    (EEPROM)
;;
cmd_WFlash:
 lds	r24, EPROMSpacePtr
 inc	r24
 rcall	Str2Val
 sts	EPROMSpacePtr, r24
 ldi	r26, 4
 clr	r27

cmd_WF_1:
 ld	r16, Y
 cpi	r16, ' '
 brne	cmd_WF_2

 adiw	r28, 1
 rcall	Str2Val
 brcc	cmd_WF_2

 st	X+, r24
 mov	r25, r24
 rcall	ByteOut
 ldi	r25, ' '
 rcall	SendByte
 rjmp	cmd_WF_1

cmd_WF_2:
 lds	r24, EPROMSpacePtr
 rjmp	f_Write
;
cmd_RFlash:
 lds	r24, EPROMSpacePtr
 inc	r24
 rcall	Str2Val
 sts	EPROMSpacePtr, r24
 
 mov	r25, r24
 rcall	ByteOut
 ldi	r25, '-'
 rcall	SendByte
 
 rcall	f_Read

 clr	r26
 clr	r27
 ldi	r16, 4

cmd_RF_1:
 ldi	r25, ' '
 rcall	SendByte
 ld	r25, X+
 rcall	ByteOut
 dec	r16
 brne	cmd_RF_1

 ldi	r25, 13
 rjmp	SendByte

;;
;;  ADC
;;
cmd_ADC:
 ldi	r24, 0x60
 rcall	Str2Val
 out	ADMUX, r24

 ldi	r16, (1<<ADEN) | (1<<ADSC) | (1<<ADFR) | (7<<ADPS0)
 out	ADCSR, r16

cmd_ADC_1:
 in	r25, ADCH
 rcall	ByteOut
 ldi	r25, ' '
 rcall	SendByte

 rcall	Wait1s

 sbis	UCSRA, RXC
 rjmp	cmd_ADC_1
 ret
;
Wait1s:
 ldi	r25, 2
 mov	Timer10b, r25
W_3:
 sbrs	Timer10b, 7
 rjmp	W_3
ret1:
 ret

;;
;;        IR
;;
cmd_IRDelaySet:
 ldi	r25, 76
 ldi	r24, 15
 rcall	Str2Val
 sts	IRDelay1, r25
 sts	IRDelay2, r24
 ret
;;
;;    
;;
cmd_Ports:
 rcall	Str2Val
 brcc	ret1
 out	PORTB, r25
 out	PORTD, r24

cmd_P:
 in	r25, PINB
 in	r24, PIND
 rcall	WordOut
 ldi	r25, ' '
 rcall	SendByte

 rcall	Wait1s

 sbis	UCSRA, RXC
 rjmp	cmd_P
 ret

;;
;;   
;;
cmd_Sleep:
 ldi	r24, (1<<SE)
 rcall	Str2Val
 out	MCUCR, r24
 sleep
ret0:
 ret

;;
;;    
;;
cmd_Power_On:
 rjmp	pw_On
;
cmd_Power_Off:
 rjmp	pw_Off

;;
;;     
;;
cmd_RTuner:
 rcall	t_Read
 rjmp	ByteOut
;
cmd_WTuner:
 lds	r24, TNDivH
 rcall	Str2Val
 sts	TNDivH, r24
 adiw	Y, 1

 lds	r24, TNDivL
 rcall	Str2Val
 sts	TNDivL, r24
 adiw	Y, 1

 lds	r24, TNCtl0
 rcall	Str2Val
 sts	TNCtl0, r24
 adiw	Y, 1

 lds	r24, TNCtl1
 rcall	Str2Val
 sts	TNCtl1, r24

 rjmp	t_Write
;
cmd_TTuner:
 rcall	print
.db	"0-7 - change divider, q - break", 13, 10, 1

cmd_TT_0:

;     

 rcall	t_Read
 rcall	ByteOut
 rcall	t_Read
 rcall	ByteOut

 rcall	RecvByte
 push	r25

 rcall	t_Read
 rcall	ByteOut

 ldi	r25, '_'
 rcall	SendByte

 rcall  cmd_RVideo

 ldi	r25, '_'
 rcall	SendByte

 pop	r25

;   

 cpi	r25, 'q'
 breq	ret0

;    TNDiv

 andi	r25, 7
 lsl	r25
 clr	r24
 ldi	r30, low(cmd_TT_t*2)
 ldi	r31, high(cmd_TT_t*2)
 add	r30, r25
 adc	r31, r24
 lpm	r24, Z+
 lpm	r25, Z

;  TNDiv
 
 lds	r16, TNDivL
 add	r16, r24
 sts	TNDivL, r16

 lds	r16, TNDivH
 adc	r16, r25
 sts	TNDivH, r16

;   

 rcall	cmd_TT_FO

;  

 rcall	t_Write

;

 rcall	print
.db	13, 10, 1
 rjmp	cmd_TT_0
;
cmd_TT_t:
.dw	1, -1, 10, -10, 100, -100, 1000, -1000

;        
; :TNDiv:(TNDiv/32)-38

cmd_TT_FO:
 ldi	r25, ':'
 rcall	SendByte

 lds	r0, TNDivL
 lds	r1, TNDivH
 rcall	DecWordOut

 ldi	r25, ':'
 rcall	SendByte

 lds	r0, TNDivL
 lds	r1, TNDivH
 ldi	r16, 32
 mov	r2, r16
 clr	r3    
 rcall	div16u

 ldi	r16, 38
 clr	r17
 sub	r0, r16
 sbc	r1, r17

 rjmp	DecWordOut

;;
;;     VideoCPU
;;
cmd_RVideo:
 rcall	v_Read
 mov	r25, VDs0
 rcall	ByteOut
 mov	r25, VDs1
 rcall	ByteOut
 mov	r25, VDs2
 rjmp	ByteOut
;
cmd_IVideo:
 rjmp	v_InitHard
;
cmd_WVideo:
 lds	r24, VideoCPUReg
 rcall	str2val
 sts	VideoCPUReg, r24 

 adiw	Y, 1

 rcall	str2val
 brcc	ret6

 mov	r16, r24
 lds	r17, VideoCPUReg
 rjmp	v_OneWrite

ret6:
 ret

;;
;;    AFC
;;
cmd_SUp:
 rcall	tv_ScanUp
 rjmp	cmd_afc_1
;
cmd_AFC:
 rcall	tv_FineTuning
cmd_afc_1:
 rcall	cmd_TT_FO
 ldi	r25, '*'
 rcall	SendByte
 rjmp	cmd_RVideo
;
cmd_SDown:
 rcall	tv_ScanDown
 rjmp	cmd_afc_1

;;
;;     OSD
;;
cmd_IOSD:
 rjmp	od_Init
;
cmd_ROSD:
 rcall	cmd_OSD_SetAddr
 movw	r24, r26
 rcall	WordOut

cmd_ROSD_1:
 rcall	i_Start

 ldi	r25, '-'
 rcall	SendByte

 ldi	r16, 0xBB
 rcall	i_SendByte
 brne	cmd_ROSD_1
 brcs	cmd_ROSD_1

 ldi	r17, 15

cmd_ROSD_2:
 ldi	r25, ' '
 rcall	SendByte

 tst	r17
 sec
 breq	cmd_ROSD_3
 clc
cmd_ROSD_3:
 rcall	i_RecvByte
 brne	cmd_ROSD_1
 mov	r25, r16
 rcall	ByteOut

 dec	r17
 brpl	cmd_ROSD_2

cmd_ROSD_4:
 rcall	i_Stop
 ldi	r25, 13
 rjmp	SendByte
;
cmd_WOSD:
 rcall	cmd_OSD_SetAddr

cmd_WOSD_1:
 ld	r16, Y
 cpi	r16, ' '
 brne	cmd_ROSD_4

 adiw	r28, 1
 rcall	Str2Val
 brcc	cmd_ROSD_4

 mov	r25, r24
 rcall	ByteOut

 mov	r16, r24
 rcall	i_SendByte
 brne	cmd_WOSD_2
 brcc	cmd_WOSD_1
 ldi	r25, 'N'
 rcall	SendByte
 rjmp	cmd_WOSD_1

cmd_WOSD_2:
 ldi	r25, '!'
 rjmp	SendByte
;
cmd_OSD_SetAddr:
 lds	r24, OSDAddrPtr
 lds	r25, OSDAddrPtr+1
 adiw	r24, 16
 rcall	Str2Val
 sts	OSDAddrPtr, r24
 sts	OSDAddrPtr+1, r25
 movw	r26, r24
 rjmp	od_SetAddr
;
cmd_ClrScr:
 rjmp	od_ClrScr
;
cmd_Print:
 rcall	Str2Val
 brcc	ret7

 sts	ODattr, r24
 mov	r26, r25
 rcall	od_Tab

cmd_P_1:
 ld	r17, Y
 cpi	r17, 13
 breq	cmd_P_2
 rcall	od_CharOut
 adiw	Y, 1
 rjmp	cmd_P_1

cmd_P_2:
 rjmp	i_Stop

;;
;;     ATmegi
;;
cmd_RDataSpace:
 lds	r24, DataSpacePtr
 lds	r25, DataSpacePtr+1
 rcall	Str2Val
 mov	r26, r24
 mov	r27, r25
 rcall	WordOut
 ldi	r25, '-'
 rcall	SendByte

c_RDS_1:
 ldi	r25, ' '
 rcall	SendByte
 ld	r25, X+
 rcall	ByteOut
 
 mov	r25, r26
 andi	r25, 0xf
 brne	c_RDS_1

 ldi	r25, 13
 rcall	SendByte
 
 sts	DataSpacePtr, r26
 sts	DataSpacePtr+1, r27
ret7:
 ret

;;
;;    
;;
cmd_Help:
 rcall	print
;.db	"Release date %DAY%.%MONTH%.%YEAR% %HOUR%:%MINUTE%", 13
.db	13
.db	"s  - Start", 13
.db	"p  - Stop", 13
.db	"g  - Get with ACK", 13
.db	"G  - Get without ACK", 13
.db	"tV - Transmit", 13
.db	13
.db	"rA   - R Flash", 13
.db	"wA N - W Flash", 13
.db	13
.db	"qD.D.C.C - W Tuner", 13
.db	"z        - R Tuner", 13
.db	"x        - T Tuner", 13
.db	13
.db	"i    - I videoCPU", 13
.db	"o    - R videoCPU", 13
.db	"vA V - W videoCPU", 13
.db	13
.db	"l - Search down", 13
.db	"j - AFC", 13
.db	"k - Search up", 13
.db	13
.db	"{ - Main power On", 13
.db	"} - Main power Off", 13
.db	13
.db	"|      - I OSD", 13
.db	"[AA    - R OSD", 13
.db	"]AA N  - W OSD", 13
.db	">      - ClrScr", 13
.db	"<CAsss	- print", 13
.db	13
.db	"mAA - R Data Space", 13
.db	"=V  - ADC monitor", 13
.db	"@VV - IRDelay set", 13
.db	".BD - PortB&D set&mon", 13
.db	"-V  - Sleep", 13
.db	13
.db	"?  - This text", 13, 1
 ret

;;
;;   AnalyseString
;;
cmd_Break:
 pop	r25
 pop	r25
 ret

;;==========================================================================
;;    +  
;;  r16, r17, r24, r25
;; Post codes:
;; 2 -    
;; 3 -   
;; 4 -    
;; 5 -      
;;

;
;   
;
pw_Off:
 cbi	roPower, pPower		;   
 cbi	roHeat1, pHeat1
 cbi	roHeat2, pHeat2

 ldi	r24, 4*3		;    3 
pw_OF_1:
 rcall	Wait250ms
 sbis	riPowerMon, pPowerMon
 ret
 dec	r24
 brne	pw_OF_1

 ldi	r24, 2			;    (  )
 rjmp	pw_Bell			; -   

;
;   
;
pw_On:
 ldi	r24, 3
 sbic	riHeatMon, pHeatMon	;   ,  
 rjmp	pw_Bell			;        - 3 

;   -    - 10 

 sbi	roHeat1, pHeat1
 ldi	r24, 10
pw_ON_1:
 cbi	roBell, pBell
 rcall	Wait250ms
 sbi	roBell, pBell
 rcall	Wait250ms
 rcall	Wait500ms
 dec	r24
 brne	pw_ON_1
 cbi	roHeat1, pHeat1

;   -    - 5 

 sbi	roHeat2, pHeat2
 ldi	r24, 5
pw_ON_2:
 cbi	roBell, pBell
 rcall	Wait500ms
 sbi	roBell, pBell
 rcall	Wait500ms
 dec	r24
 brne	pw_ON_2
 cbi	roHeat2, pHeat2

;  1/2  -      

 rcall	Wait500ms

;   

 sbi	roPower, pPower

;  1      

 rcall	Wait500ms
 rcall	Wait500ms

 ldi	r24, 4
 sbis	riPowerMon, pPowerMon
 rjmp	pw_Bell

;    -       ...

 ldi	r24, 5
 sbic	riHeatMon, pHeatMon	; ...  5 
 ret

;
;   ,    r24 
;    
;
pw_Bell:
 cbi	roPower, pPower		;   
 cbi	roHeat1, pHeat1
 cbi	roHeat2, pHeat2
 mov	r25, r24

pw_B_2:
 cbi	roBell, pBell
 rcall	Wait250ms
 sbi	roBell, pBell
 rcall	Wait250ms
 dec	r25
 brne	pw_B_2

 rcall	Wait500ms
 rcall	Wait500ms
 rcall	Wait500ms
 rcall	Wait500ms
 rjmp	pw_Bell

;;==========================================================================
;;     
;;     
;;  i2c [r16, r24, r25] 
;;     [r0..r2], r17, r23
;; tv_Scan*   v_Write [X, Z]
;;

;
;       TNDiv
;
tv_ScanDown:
 ldi	r23, -20
 rjmp	tv_su_0

;
;       TNDiv
;
tv_ScanUp:
 ldi	r23, 20
tv_su_0:

 push	r23
 rcall	v_MuteOn
 pop	r23

 clt
 rcall	tv_FlowFreq		;    
 set
 rcall	tv_FlowFreq		;   
 rcall	tv_FineTuning		;    

 rjmp	v_MuteRestore

;
;     AFC   
;        / 
;
tv_FineTuning:
	rcall	cmd_RVideo
	rcall	cmd_TT_FO
 rcall	tv_IsStation
 brcc	ret5			;    -   
 bst	rVD_AFA, pVD_AFA
 brts	ret5			; AFA == 1:    

;!!!!!!!!!!!!!
	ldi	r25, '.'
	rcall	SendByte
 ;cpl	BELL

 ldi	r23, -1		;  ,   .   
 sbrc	rVD_AFB, pVD_AFB
 ldi	r23, 1

 rcall	tv_TuneAndBandSwitch
 brcs	tv_FineTuning
ret5:
 ret

;
;      r23,  / 
; : T = 1 -    , T = 0 -     
;       -
;
tv_FlowFreq:
 rcall	tv_TuneAndBandSwitch
 brcc	ret4			;   
;!!!!!! jb	IRRecv, ret4		;   -  
	ldi	r25, '>'
	rcall	SendByte
; cpl	BELL

 push	r23
 rcall	tv_IsStation
 pop	r23
 bld	r17, 7
 ror	r16
 eor	r16, r17		; C = C xor T
 rol	r16
 brcs	tv_FlowFreq
ret4:
 ret

;
;     TNDiv + r23, ,   
; C = 0,            
;
;   ,  , 
;        :
; I:	0x09, 0x18,	II:	0x14, 0x3d,	III:	0x38, 0x71
;
;  :  .     ,  
;        ,
;         C = 0 [  ~39..960 ]
;     (  ): 0x12, 0x26, 0x57
;
;         ,
;           
; (,          ).
;  ,     ,     ,
;    ,       .
;
tv_TuneAndBandSwitch:
 mov	r16, r23

tv_TABS_4:
 rcall	t_Tune
 brcs	ret3

 lds	r16, TNDivH

 ldi	r17, 0x80
 cpi	r16, 0x12
 brlo	tv_TABS_2	; TNDivH < 0x12

 ldi	r17, 0x21
 cpi	r16, 0x26
 brlo	tv_TABS_2	; 0x12 =< TNDivH < 0x26

 ldi	r17, 0x42
 cpi	r16, 0x57
 brlo	tv_TABS_2	; 0x26 =< TNDivH < 0x57

 ldi	r17, 0x08	; 0x57 =< TNDivH

tv_TABS_2:
 sbrs	r23, 7		;       
 swap	r17
 andi	r17, 0x0F
 breq	ret_CC		; 0 -   C = 0 -  
 sbrc	r17, 3
 rjmp	ret_CS		; 8 -   C = 1 -    [  ,    ]
 sts	TNCtl1, r17	;  
 		ldi	r25, '*'
		rcall	SendByte
 		mov	r25, r17
		rcall	ByteOut
 clr	r16
 rjmp	tv_TABS_4

;
;       Video Ident
; C = 1,     
;
tv_IsStation:
 ldi	r23, 10			;       20 ms
				;   ,    4..6 ms
tv_IS_1:
 rcall	Wait2ms			;  : 2ms -  AGC increase, 10 ms -  Video Ident
 rcall	v_Read
 sbrc	rVD_IFI, pVD_IFI	; IFI == 0: Video  
 sbrs	rVD_SL, pVD_SL		; SL  == 0:   f1 -    AFA  AFB
 rjmp	tv_IS_2
ret_CS:
 sec				; IFI == SL == 1:  
ret3:
 ret

tv_IS_2:
 dec	r23
 brne	tv_IS_1
ret_CC:
 clc				;   
 ret

;;==========================================================================
;;  i2c
;;  r16, r24, r25 (Z ,  )
;; Prescaller = const = 00
;;

;
; 
;
i_Init:
 ldi	r16, twibr
 out	TWBR, r16
; clr	r16		!!!!
; out	DDR
; out	PORT
 ret
;
;  "Start"
;       Stop [ -     SDA = SCL ]
;  Z = 0   
;
i_Start:
 ldi	r16, (1<<TWINT) | (1<<TWSTA) | (1<<TWEN)
 out	TWCR, r16
 rjmp	i_WaitReady
;
;  "Stop"
;    -ɣ  [,  SCL  SDA    = 0 ]
; SREG   !!!
; ,     ATmega     ,
;     
;
i_Stop:
 ldi	r16, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
 out	TWCR, r16
 ret
;
; Send byte
;   r16,  C = 0    
; Z = 0    ( ̣   Z = 1).
; [ ,  , SCL = 0  ,  SDA = SCL = 0 ]
;
i_SendByte:
 out	TWDR, r16
 ldi	r16, (1<<TWINT) | (1<<TWEN)
 out	TWCR, r16
 rjmp	i_WaitReady
;
; Recv byte
;      C = 0, r16 -  
; Z = 0   
; [        SDA = SCL = 0 ]
;
i_RecvByte:
 ldi	r16, (1<<TWINT) | (1<<TWEN)
 brcs	i_RB_1
 ori	r16, (1<<TWEA)
i_RB_1:
 out	TWCR, r16
 rcall	i_WaitReady
 in	r16, TWDR
 ret
;
;   I2C
;   TWSR == 0   !!! [   ]
;    Z = 0     Z = 1 -  
;  Z = 1   C = 0   ACK  C = 1 -  NACK
;       i_Stop
;
i_WaitReady:
 in	r16, TWCR	; sbis	TWCR, TWINT
 sbrs	r16, TWINT
 rjmp	i_WaitReady

 in	r16, TWSR
 ldi	r24, 10
 push	r30
 push	r31
 ldi	r30, low(i_Table*2)
 ldi	r31, high(i_Table*2)

i_W_1:
 lpm	r25, Z+
 cp	r25, r16	; cpse may be ?
 breq	i_W_2
 dec	r24
 brne	i_W_1

 rcall	i_Stop
 rjmp	i_W_3
 
i_W_2:
 lsr	r24	;  C
 sez

i_W_3:
 pop	r31
 pop	r30
 ret

; "" .   - NACK
i_Table:
.db	0x08, 0x10,  0x18, 0x20, 0x28, 0x30,  0x40, 0x48, 0x50, 0x58

;;==========================================================================
;;   
;;  i2c [r16, r24, r25] 
;;     [VDs*: r0..r2], r17
;; v_Write      [r23, X, Z]
;;

;
;   Sound Mute
;
v_MuteOff:		;  
 lds	r16, VDc14
 cbr	r16, 0x80
 rjmp	v_mo_1
;
v_MuteOn:		;       
 lds	r16, VDc14
 sts	VDc14a, r16
 sbr  	r16, 0x80
 rjmp	v_mo_1
;
v_MuteRestore:		;   
 rcall	Wait250ms
 clr	IRRecv		; MuteRestore     ,
			;         
 lds	r16, VDc14a
 rjmp	v_mo_1
;
v_MuteChg:		;   
 lds	r16, VDc14
 ldi	r24, 0x80
 eor	r16, r24

v_mo_1:
 sts	VDc14, r16
 rjmp	v_Write
;
;   r17   r16
; !!!!!        !!!!!
; !!!!!    !!!!!
;
v_OneWrite:
 push	r16
 rcall	v_SetAddr
 pop	r16
 rcall	i_SendByte
 rjmp	i_Stop
;
;     (ROM -> VDc*)
;
v_InitVal:
 ldi	r30, low(v_itable*2)	; Z
 ldi	r31, high(v_itable*2)
 ldi	r26, low(VDc)		; X
 ldi	r27, high(VDc)

 ldi	r23, VDcCNT

v_i_1:
 lpm	r16, Z+
 st	X+, r16
 dec	r23
 brne	v_i_1
 ret
;
;    [],  v_Write
;    v_InitVal
;
v_InitHard:
 rcall	v_Read
 sbrc	rVD_POR, pVD_POR
 rjmp	v_InitHard
;
;      VDc*
;
v_Write:
 ldi	r30, low(v_atable*2)	; Z
 ldi	r31, high(v_atable*2)
 ldi	r26, low(VDc)		; X
 ldi	r27, high(VDc)

 ldi	r23, VDcCNT

v_w_1:
 lpm	r17, Z+
 rcall	v_SetAddr

 ld	r16, X+
 rcall	i_SendByte
 brne	v_Write		;  
 brcs	v_Write		; NASK

 dec	r23
 brne	v_w_1

 rjmp	i_Stop

;   

v_atable:
.db	0x00, 0x01, 0x02, 0x03
.db	0x08, 0x09, 0x0a, 0x0b
.db	0x0c, 0x0d, 0x0e, 0x0f
.db	0x10, 0x11, 0x12, 0x13
.db	0x14, 0x15
.db	0x18, 0x19, 0x1a, 0x1b

;   

v_itable:
.db	0x03, 0xd0, 0xe0, 0x20
.db	0x20, 0xe0, 0x20, 0x20
.db	0x20, 0x20, 0x20, 0x20
.db	0x20, 0xa0, 0x10, 0x00
.db	0x10, 0x60
.db	0x00, 0x00, 0x00, 0x00
;
;     r0..r2
;
v_Read:
 clr	r17		;    ,    
 rcall	v_SetAddr	;   Start,       
			;  POR = 0
 rcall	i_Start
 ldi	r16, 0x8B
 rcall	i_SendByte
 brne	v_Read		;  
 brcs	v_Read		; NASK

 clc
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs0, r16

 clc
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs1, r16

 sec
 rcall	i_RecvByte
 brne	v_Read		;  
 mov	VDs2, r16

 rjmp	i_Stop

;     [ r17]

v_SetAddr:
 rcall	i_Start
 ldi	r16, 0x8A
 rcall	i_SendByte
 brne	v_SetAddr	;  
 brcs	v_SetAddr	; NASK

 mov	r16, r17
 rcall	i_SendByte
 brne	v_SetAddr	;  
 brcs	v_SetAddr	; NASK
 ret

;;==========================================================================
;; TUNER interface
;;  i2c [r16, r24, r25], r17
;;

;
;    r16 () + TNDiv,
;    (FL = 1)  C = 1
;
t_Tune:
 clr	r17
 sbrc	r16, 7
 com	r17
t_t_1:
 lds	r24, TNDivL
 add	r16, r24
 sts	TNDivL, r16
 lds	r25, TNDivH
 adc	r17, r25
 sts	TNDivH, r17

 rcall	t_Write

 ldi	r17, 250	;  500 .   ,   150 
t_t_2:			;   dx = 1  t ~ 2..4 ms,  dx = 20  t ~ 8 ms
 rcall	Wait2ms		;      , , 158 ms
 rcall	t_Read
 dec	r17
 sbrs	r25, 6
 brne	t_t_2
 rol	r25
 rol	r25
 ret 
;
;    
;
t_Write:
 rcall	i_Start
 ldi	r16, 0xC0
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNDivH
 cbr	r16, 0x80
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNDivL
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNCtl0
 sbr	r16, 0x80
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK

 lds	r16, TNCtl1
 rcall	i_SendByte
 brne	t_Write		;  
 brcs	t_Write		; NASK
 
 rjmp	i_Stop
;
;      r25
;
t_Read:
 rcall	i_Start
 ldi	r16, 0xC1
 rcall	i_SendByte
 brne	t_Read		;  
 brcs	t_Read		; NASK
 sec
 rcall	i_RecvByte
 brne	t_Read
 mov	r25, r16
 rjmp	i_Stop

;;==========================================================================
;; OnScreenDisplay interface
;;  i2c [r16, r24, r25], X
;; od_ClrScr  od_Init   r17  Z
;;

;
;  OSD
;
od_Init:
 ldi	r30, low(od_Table*2)
 ldi	r31, high(od_Table*2)

 ldi	r26, 0xF0	;   
 ldi	r27, 0x3F
 ldi	r17, 8
 rcall	od_i_2

 clr	r26		;   
 clr	r27
 ldi	r17, 18
;
od_i_2:
 rcall	od_SetAddr
od_i_1:
 lpm	r16, Z+
 rcall	i_SendByte
 brne	od_Init		;  
 brcs	od_Init		; NASK
 dec	r17
 brne	od_i_1
 rjmp	i_Stop
;
od_Table:
.db	0x20, 0x14, 0x24, 0x90, 0x22, 0x33, 0xE0, 0x05

.db	0x16, 0x00		; Spacing -   VSync   
.db	0x40, 0xC0		; 0- 
.db	0x80, 0xC0		; 1- 
.db	0xC0, 0xC0		; 2- 
.db	0x00, 0xC1		; 3- 
.db	0x40, 0xC1		; 4- 
.db	0x80, 0xC1		; 5- 
.db	0xC0, 0xC1		; 6- 
.db	0x14, 0x00		; Spacing -     6- 

;
;  
;
od_ClrScr:
 ldi	r26, 0x20		;  ,  
 rcall	od_Tab
 ldi	r16, B_TRANS
 sts	ODattr, r16
 ldi	r17, ' '
 ldi	r30, 32*7

od_cs_1:
 rcall	od_CharOut
 dec	r30
 brne	od_cs_1
 
; clr	CH_ind			;       -    
 rjmp	i_Stop

;
;   r17   ODattr.    od_Tab,    i_Stop
;  i2c   !!! [SetAddr      ,      ]
;
od_CharOut:
 lds	r16, ODattr
 rcall	i_SendByte

 mov	r16, r17
 cpi	r16, ' '
 brne	od_CO_1
 ldi	r16, 0x80+63	;   stv9425   
od_CO_1:
 rjmp	i_SendByte

;
;   (   OSD)    r26   
; D7..D5 -   (1..6), D4..D0 -   (0..21)
;
od_Tab:
 clr	r27
 lsl	r26
 rol	r27

;
;     OSD  X
;
od_SetAddr:
 rcall	i_Start
 ldi	r16, 0xBA
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK

 mov	r16, r26
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK

 mov	r16, r27
 andi	r16, 0x3F
 rcall	i_SendByte
 brne	od_SetAddr	;  
 brcs	od_SetAddr	; NASK
 ret

;;==========================================================================
;;      (EEPROM)
;;   , 128   4  
;;  r16, r24, r25, r0-r7, X
;;

;
;   r24   r0, r1, r2, r3
;
f_Read:
 rcall	f_CalcAddr
 rcall	f_WWait

 out	EEARH, r25
 clr	r26
 clr	r27
 rcall	f_GetByte
 rcall	f_GetByte
 rcall	f_GetByte
;
;   ,   (X)
;
f_GetByte:
 out	EEARL, r24
 inc	r24

 sbi	EECR, EERE
 in	r16, EEDR
 st	X+, r16
 ret
;
;    (r24:r25)    (r24)
;
f_CalcAddr:
 clr	r25
 lsl	r24
; rol	r25
 lsl	r24
 rol	r25
 ret
;
;   
;         sleep modes !
;
f_WWait:
 sbic	EECR, EEWE
 rjmp	f_WWait
 ret
;
;   r24  r4, r5, r6, r7
;
f_Write:
 rcall	f_CalcAddr
 ldi	r26, 4
 clr	r27

 rcall	f_PutByte
 rcall	f_PutByte
 rcall	f_PutByte
;
;     (X)
;
f_PutByte:
 rcall	f_WWait

 out	EEARH, r25
 out	EEARL, r24
 inc	r24

 ld	r16, X+
 out	EEDR, r16
 cli			;        -   ...
 sbi	EECR, EEMWE	; ...   
 sbi	EECR, EEWE
 sei
ret2:
 ret

;;==========================================================================
;; 
;;  r0..r7, r16, r25
;;

;* Title:		Multiply and Divide Routines
;* Version:		1.1
;* Last updated:	97.07.04
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor).
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;*
;***************************************************************************
; input:	r1, r0 = Dividend X
; 		r3, r2 = Divisor Y
;
; output:	r1, r0 = quotient Q of division
;		r7, r6 = remainder
;
; r1:r0 / r3:r2 = r1:r0 [r7:r6]		Q = X / Y
;
;***** Subroutine Register Variables

.def	dd16uL	= r0
.def	dd16uH	= r1
.def	dv16uL	= r2
.def	dv16uH	= r3

.def	dres16uL= r0
.def	dres16uH= r1
.def	drem16uL= r6
.def	drem16uH= r7

.def	dcnt16u	= r16

;***** Code

div16u:	clr	drem16uL		;clear remainder Low byte
	sub	drem16uH, drem16uH	;clear remainder High byte and carry
	ldi	dcnt16u, 17		;init loop counter
d16u_1:	rol	dd16uL			;shift left dividend
	rol	dd16uH
	dec	dcnt16u			;decrement counter
	brne	d16u_2			;if done
	ret				; return
d16u_2:	rol	drem16uL		;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL, dv16uL	;remainder = remainder - divisor
	sbc	drem16uH, dv16uH
	brcc	d16u_3			;if result negative
	add	drem16uL, dv16uL	; restore remainder
	adc	drem16uH, dv16uH
	clc				; clear carry to be shifted into result
	rjmp	d16u_1			;else
d16u_3:	sec				; set carry to be shifted into result
	rjmp	d16u_1

;
;       dd16uL:dd16uH
;
DecWordOut:
 ldi	r16, 10
 mov	dv16uL, r16
 clr	r16
 push	r16
 mov	dv16uH, r16

dwo_1:
 rcall	div16u

 ldi	r16, '0'
 add	drem16uL, r16
 push	drem16uL

; movw	dd16uL, dres16uL

 mov	r16, dd16uL
 or	r16, dd16uH
 brne	dwo_1

dwo_2:
 pop	r25
 tst	r25
 breq	ret2
 rcall	SendByte
 rjmp	dwo_2
